;searchfast.au3 0_18  
;Search Engine/Index Engine
;Author: Brian Prike aka The Kandie Man
;tested and compiled with AutoIt v3.1.1.70 (BETA)
;an attempt to compile this with a non-beta version of AutoIt will result in failure, your failure, and then we will all point and laugh at you
;Special thanks to Alex Peters aka LxP of Melbourne, Australia for help when the project was in early development.  Also to SmOke_N for helping me.  Special thanks to Autoit support.   http://www.autoitscript.com/forum
;known issue:  This program will have to re-index the same drives if you have a dual windows boot and the drives don't have the same drive letter names
;this file has been commented on, mostly
;Must Edit line 128 before compile so that it has the correct location of the help file
;Special thanks to Randallc for the DOS Engine Design
;hides the tray(obviously)
#region startup
;#NoTrayIcon
Opt("RunErrorsFatal", 0)
;a small error handler, just gets rid of the ugly autoit error, i hope.  Comment it out when debugging
ObjEvent("AutoIt.Error", "Error")
;some files to include, not sure which ones i actually still need since i didn't delete them after i got rid of some functions that required them
#include <GuiConstants.au3>
#include <misc.au3>
#include <file.au3>
#include <date.au3>
#include <Array.au3>
;#Include <GuiListView.au3>
#include "_GUICtrlListView.au3"
;~ #include "_GUICtrlListViewIMG.au3"

;#include "_GUICtrlListViewIconSet.au3"
#include <process.au3>
$i_DefaultIconNumber=1000 ;default icon display 300

;a whole bunch of declared global variables
;not even sure which ones i don't use, but haven't bothered since they don't use that much memory:P
Global $mainGUI,$szIconFile
Global $s_ComputerName=@ComputerName
Global $indexstatuslabel, $indexmainlabel
Global $number,$s_AnswerFile = @ScriptDir & "AnswerFindLines.txt"
_FileCreate(@ScriptDir&"\AnswerFindLines.txt")
$s_AnswerFile=FileGetShortName($s_AnswerFile)
Global $number,$s_AnswerFile_DosIndex = @ScriptDir & "AnsFullPath.txt"
_FileCreate(@ScriptDir&"\AnsFullPath.txt")
$s_AnswerFile_DosIndex=FileGetShortName($s_AnswerFile_DosIndex)
Global $filetosave
Global $file
Global $filesize
Global $usercancel
Global $drive
Global $filearray
Global $filetosave = @ScriptDir & "\indexdata.index"
Global $searchquierie
Global $filetosavehandle
Global $filepath
Global $fixeddrives
Global $indexoutput
Global $indexinput
Global $fileoutput
Global $filecounter
Global $CurrentFile, $s_CurrentFile
Global $titleindex
Global $ExportFile
Global $closebuttonstatus
Global $searchlistView ;so that it can be used by GUISETONEVENT functions
Global $B_DESCENDING[6] ;used for the number of columns in the search list view
Global $timerstamp ; a timerstamp used by the list view to determine if the user double clicked by finding the difference in time between the two clicks
Global $current2 ;used to determine the current object selected in the listview
Global $searchlisviewmenu ;so that it can be used by the GUISETONEVENT functions
;update management
;write the current version of this .exe to the ini file so that the autoupdater knows what version it is
INIWrite(@ScriptDir & "\version.ini","Version","Current Version","1.5.1.9 build9")
;If FileExists(@ScriptDir & "\SEUpdate.exe") Then
;	Run(@ComSpec & " /c " & "@start " & FileGetShortName(@ScriptDir & "\SEUpdate.exe"), "", @SW_HIDE)
;EndIf
;used GUI builder created by CyberSlug
$mainGUI = GUICreate("Fast Search Engine", 600, 300, (@DesktopWidth - 600) / 2, (@DesktopHeight - 300) / 2) ;$WS_OVERLAPPEDWINDOW + $WS_VISIBLE + $WS_CLIPSIBLINGS)
$lblasdf = GUICtrlCreateGroup("Search", 10, 60, 580, 110)
$Label_2 = GUICtrlCreateLabel("Fast Search Engine", 200, 35, 200, 30, $ES_CENTER)
$searchquierieinput = GUICtrlCreateInput("", 250, 90, 310, 20)
$Label_4 = GUICtrlCreateLabel("A filename or part of a filename to search for:", 20, 90, 210, 20)
$startsearchbutton = GUICtrlCreateButton("Search", 200, 130, 100, 30)
$Group_6 = GUICtrlCreateGroup("Indexing", 10, 180, 580, 100)
$rebuildindexbutton = GUICtrlCreateButton("Rebuild Index", 260, 220, 80, 30)
$helpbutton = GUICtrlCreateButton("Help", 500, 10, 75, 20)
$getindextime = GUICtrlCreateButton("Get Index Date", 390, 220, 80, 30)
$DrivesAll= GUICtrlCreateCheckbox("Drives All [Off Fixed]", 310, 130, 250, 15)
GUICtrlSetState ($DrivesAll,$GUI_CHECKED)
GUICtrlSetState($startsearchbutton, $GUI_DEFBUTTON)
GUICtrlSetFont($Label_2, 14)
GUICtrlCreateLabel("Search for files in:", 20, 133, 100, 30)
;===================~ $fastradio = GUICtrlCreateRadio("Fast Search(Uses all CPU. Can't control GUI)", 310, 120, 250, 25)
GUICtrlCreateLabel("Index the files in:", 60, 233, 100, 30)
Global $s_DriveTypes=_iif(GUICtrlRead($DrivesAll)>1,"FIXED","ALL")
$drivecombo = GUICtrlCreateCombo($s_DriveTypes&" Drives", 110, 130, 70, 30, $CBS_DROPDOWNLIST)
$drivecomboindex = GUICtrlCreateCombo($s_DriveTypes&" Drives", 150, 230, 70, 30, $CBS_DROPDOWNLIST)
$fixeddrives = DriveGetDrive( $s_DriveTypes)
;_ArrayDisplay($fixeddrives,"1")
For $count = ubound($fixeddrives)-1 to 1 step -1
	if DriveGetType( $fixeddrives[$count] )="REMOVABLE" or DriveGetType( $fixeddrives[$count] )="CDROM" or StringInStr($fixeddrives[$count],"a") Then
		_ArrayDelete($fixeddrives,$count)
		;$count += 1
	EndIf
Next
;~ _ArrayDisplay($fixeddrives,"2")
If Not @error Then
	GUICtrlSetData($drivecombo, "", $s_DriveTypes&" Drives")
	GUICtrlSetData($drivecombo, $s_DriveTypes&" Drives", $s_DriveTypes&" Drives")
	For $i = 1 To ubound($fixeddrives)-1
		GUICtrlSetData($drivecombo, StringUpper($fixeddrives[$i]), $s_DriveTypes&" Drives")
		GUICtrlSetData($drivecomboindex, StringUpper($fixeddrives[$i]), $s_DriveTypes&" Drives")
	Next
EndIf
;===================~ $slowradio = GUICtrlCreateRadio("Slower Search(Can stop search midway/open files)", 310, 140, 270, 25)
;~ GUICtrlSetState($fastradio, $GUI_CHECKED)
GUISetState()
_ReduceMemory()
#endregion
While 1
	;while loop for the main GUI, the very simple main one that starts up first
	$msg = GUIGetMsg()
	$readdrivecomboindex = GUICtrlRead($drivecomboindex)
	Select
		Case $msg = $GUI_EVENT_CLOSE
			ExitLoop
		Case $msg = $getindextime
			$listtodisplay = ""
			For $count = 1 to ubound($fixeddrives)-1
				if FileExists(@scriptdir & "\"&$s_ComputerName&"FastSearch_DBtitle" & StringTrimRight(StringUpper($fixeddrives[$count]),1)& ".index") then
					$listtodisplay &= "Index for drive " & StringUpper($fixeddrives[$count]) & " was last updated "
					$timestamp = FileGetTime(@scriptdir & "\"&$s_ComputerName&"FastSearch_DBtitle" & StringTrimRight(StringUpper($fixeddrives[$count]),1) & ".index",0)
					$nonarraytimestamp = ""
					$nonarraytimestamp =  $timestamp[0] & "/" & $timestamp[1] & "/" & $timestamp[2] & " at " & $timestamp[3] & ":" & $timestamp[4] & ":"& $timestamp[5] & @CRLF
					$listtodisplay &= $nonarraytimestamp
				EndIf
			Next
			$listtodisplay = StringTrimRight($listtodisplay,1)
			If Not @error Then
				GUICtrlSetData($drivecomboindex, "", $s_DriveTypes&" Drives")
				GUICtrlSetData($drivecomboindex, $s_DriveTypes&" Drives", $s_DriveTypes&" Drives")
				GUICtrlSetData($drivecomboindex, $readdrivecomboindex, $readdrivecomboindex)
				For $i = 1 To ubound($fixeddrives)-1
					GUICtrlSetData($drivecombo, StringUpper($fixeddrives[$i]), $readdrivecomboindex)
					GUICtrlSetData($drivecomboindex, StringUpper($fixeddrives[$i]),$readdrivecomboindex)
				Next
				GUICtrlSetData($drivecombo, "ALL Drives", "ALL Drives")
			EndIf
			MsgBox(64,"Index Files Last Updated:","The following index files were last updated:" & @CRLF & @CRLF & $listtodisplay)
		Case $msg = $startsearchbutton
			If GUICtrlRead($searchquierieinput) <> "" Then
				Call(StartSearch())
			Else
				MsgBox(48, "Error", "You didn't enter a search query.")
			EndIf
		Case $msg = $rebuildindexbutton
			CMDIndex()
		Case $msg = $helpbutton
			;Local $helplocation = @ScriptDir & "\help.htm"
			;FileInstall("C:\AUTO it Scripts\Search Engine\compiled released\help.htm", $helplocation, 1)
			;Run(@ComSpec & " /c " & FileGetShortName($helplocation), "", @SW_HIDE)
	EndSelect
WEnd
;===================================================
Func StartSearch()
	$s_DriveTypes=_iif(GUICtrlRead($DrivesAll)>1,"FIXED","ALL")
	$fixeddrives = DriveGetDrive( $s_DriveTypes)
	$readdrivecomboindex = GUICtrlRead($drivecomboindex)
	$n1TimerQuery = TimerInit()
	Opt("GUIOnEventMode", 1)
	$usercancel = "false"
	$filecounter = 0
	$closebuttonstatus = "false"
	HotKeySet("{Esc}", "Cancel")
	If Not FileExists(@ScriptDir & "\results.txt") Then
		_FileCreate(@ScriptDir & "\results.txt")
	EndIf
	GUISetState(@SW_HIDE, $mainGUI)
	$readdrivecombo = GUICtrlRead($drivecombo)
	$searchquierie = GUICtrlRead($searchquierieinput)
	$searchGUI = GUICreate("Searching... (Esc cancels)", 810, 623, (@DesktopWidth - 800) / 2, (@DesktopHeight - 600) / 2,$WS_MAXIMIZEBOX  + $WS_MINIMIZEBOX)
	;set on event which allows the interface to respond to the user while it is searching
	$timerstamp = TimerInit()
	GUISetOnEvent($GUI_EVENT_CLOSE, "SpecialEvents")
	GUISetOnEvent($GUI_EVENT_MINIMIZE, "SpecialEvents")
	GUISetOnEvent($GUI_EVENT_RESTORE, "SpecialEvents")
	GUISetOnEvent($GUI_EVENT_PRIMARYDOWN, "PrimaryDown")
	$openbutton = GUICtrlCreateButton("Open", 10, 550, 50, 20)
	GUICtrlSetOnEvent(-1, "OpenPressed")
	$stopbutton = GUICtrlCreateButton("Stop", 70, 550, 50, 20)
	GUICtrlSetOnEvent(-1, "StopPressed")
	$searchlistView = _GUICtrlCreateListView("Filename|Location|Size [Kb]|Date Modified|Date Created|Extension", 10, 10, 790, 530, $LVS_REPORT)
	;NOT HERE_FileSetIconDefault($searchlistView);_FileSetIconDefault(".doc" )
	;MsgBox(0,"","$s_ExtDefault="&$s_ExtDefault)
	GUICtrlSetOnEvent(-1, "ListViewClicked")
	$searchlisviewmenu = GUICtrlCreateContextMenu($searchlistView)
	$fileitemOpen = GUICtrlCreateMenuItem("Open", $searchlisviewmenu)
	GUICtrlSetOnEvent(-1, "OpenPressed")
	$statuslabel = GUICtrlCreateLabel("", 10, 580, 790, 20)
	$statuslabel2 = GUICtrlCreateLabel("", 130, 550, 790, 20)
	$timestatuslabel = GUICtrlCreateLabel("", 130, 565, 790, 15)
	GUISetState()
	GUISetState(@SW_MAXIMIZE)
	For $intcouter = 0 to Ubound($B_DESCENDING)-1
		_GUICtrlListViewSetColumnWidth($searchlistView, $intcouter, (@DesktopWidth-20)/Ubound($B_DESCENDING))
	Next
	_GUICtrlListViewSetColumnWidth($searchlistView, 2, 20)
	_GUICtrlListViewSetColumnWidth($searchlistView, 1, 300)
	_GUICtrlListViewSetColumnWidth($searchlistView, 0, 200)
	_GUICtrlListViewJustifyColumn ($searchlistView, 2, 1)
	;$searchquierie=StringReplace($searchquierie,"*","%")
	;$searchquierie=StringReplace($searchquierie,"?","_")
	$statuslabel = GUICtrlCreateLabel("", 10, 580, 790, 20)
	Local $InFile = '...'
	Local $OutFile = @ScriptDir & "\results.txt"
	Local $Search = '...'
	Local $i = 0, $ar_Dirs[1],$s_Dirs
	Local $j = 0,$fileNameLast,$s_SuccessDelete
	Local $searchlistitemarray
	Dim $masterfilecounter
	$masterfilecounter = 0
	$s_AnswerFile=@ScriptDir&"\AnswerFindLines.txt"
	$s_AnswerFileSorted=@ScriptDir&"\AnsSorted.txt"
	if not FileDelete($s_AnswerFile) then $s_AnswerFile=@ScriptDir&"\AnswerFindLines"&@hour&@MIN&@SEC&".txt"
	;===========================================================================================================
	If $readdrivecombo = "ALL Drives" Then
		$searchbegin = TimerInit()
		$1secondtimestamp = TimerInit()
		$current = _GUICtrlListViewGetHotItem ($searchlistView)
		For $i = 1 To ubound($fixeddrives)-1
			;MsgBox(0,"","$i ="&$i )
			$filepath = @ScriptDir & "\"&$s_ComputerName&"FastSearch_DBtitle" & StringTrimRight($fixeddrives[$i], 1) & ".index"
			$sFile = @ScriptDir & "\"&$s_ComputerName&"FastSearch_"& StringUpper(StringTrimRight($fixeddrives[$i], 1))&"_.txt"
			$masterfilecounter+=_FileCountLines($sFile)
			;MsgBox(0,"","$sFile ="&$sFile )
			$masterindexpath = @ScriptDir & "\"&$s_ComputerName&"FastSearch_DBmasterindex" & StringTrimRight($fixeddrives[$i], 1) & ".index"
			Local $InHandle = FileOpen($masterindexpath, 0)
			local $s_Drop="",$sOutput
			If not ($InHandle = -1) and  FileExists(  $sFile) Then
				;===========================================================================================================
				$s_DefSwitches='/I  /c:"'&$searchquierie&'"'       ; Change only if you know FINDSTR switches well
				$Append=_Iif($i=1,0,1)
				_FindLinesDOSsearchOLD($sFile,$s_AnswerFile,$s_DefSwitches,$Append); AnswerFile ByRef
				;_DosIndex($s_AnswerFile,$Append,$searchquierie,$fixeddrives[$i])
				;===========================================================================================================
			EndIf
			Local $OutHandle = FileOpen($OutFile, 1)
			FileWriteLine($OutHandle, "Search for results for '" & $searchquierie & "' on drive " & $fixeddrives[$i] & ".")
			FileClose($InHandle)
			FileClose($OutHandle)
		Next
		FileClose($s_AnswerFile)
	Else
		$searchbegin = TimerInit()
		$1secondtimestamp = TimerInit()
		$current = _GUICtrlListViewGetHotItem ($searchlistView)
		$filepath = @ScriptDir & "\"&$s_ComputerName&"FastSearch_DBtitle" & StringTrimRight($readdrivecombo, 1) & ".index"
		$sFile = @ScriptDir & "\"&$s_ComputerName&"FastSearch_"& StringUpper(StringTrimRight($readdrivecombo, 1))&"_.txt"
		$masterindexpath = @ScriptDir & "\"&$s_ComputerName&"FastSearch_DBmasterindex" & StringTrimRight($readdrivecombo, 1) & ".index"
		Local $InHandle = FileOpen($masterindexpath, 0)
		$masterfilecounter+=_FileCountLines($sFile)
		If $InHandle = -1 Then
			MsgBox(48, "No Index File Found", "No index file found for drive " & $readdrivecombo & ". Please rebuild the index.  " & @CRLF & @CRLF & "If this is your first time using this search engine, you must build an index.  Please select the drive you wish to build the index for on the main screen in the indexing group box. Then click the 'Rebuild Index' button." & @CRLF & @CRLF & "Once the index has been built the search engine should work faster than the explorer search companion.  It can take as little as 10 min to build an index, though it will most likely take longer.  The time it takes to build an index is determined by how many drives you have and how many files you have.")
			$usercancel = "true"
		EndIf
		Local $OutHandle = FileOpen($OutFile, 1)
		FileWriteLine($OutHandle, "Search for results for '" & $searchquierie & "' on drive " & $readdrivecombo & ".")
		;===========================================================================================================
		$s_DefSwitches='/I  /c:"'&$searchquierie&'"'       ; Change only if you know FINDSTR switches well
		_FindLinesDOSsearchOLD($sFile,$s_AnswerFile,$s_DefSwitches,0); AnswerFile ByRef
		;===========================================================================================================
		FileClose($InHandle)
		FileClose($OutHandle)
	EndIf
	;===========================================================================================================
	_Search_VBSText($s_AnswerFile,$s_AnswerFileSorted,$searchquierie)
	while not FileGetSize($s_AnswerFileSorted)
		sleep(50)
	wend
	$timerstamp1 = TimerInit()
	;_FileSetIconDefault($searchlistView,-1,".doc" )
	ConsoleWrite("_FileSetIconDefault :"&round(TimerDiff($timerstamp1)) & " mseconds to search."&@lf)
	$In2Handle=fileopen($s_AnswerFileSorted,0)
	if _FileCountLines($s_AnswerFileSorted)<=$i_DefaultIconNumber then
	_FileSetIconDefault($searchlistView,$s_AnswerFileSorted);_FileSetIconDefault($searchlistView,-1,".doc" )
		;_GUICtrlSetImage($searchlistView, "mmcndmgr.dll", 96)   ;Set Icons for records
	EndIf
		while 1
			Local $Line = FileReadLine($In2Handle)
			If @error Then ExitLoop
			If $usercancel = "true" Then ExitLoop
			If $closebuttonstatus = "true" Then ExitLoop
			$nIcon=0
			$ar_Line=StringSplit($Line, "|")
				_GUICtrlCreateListViewItem($Line, $searchlistView,$ar_Line[2])
			$j = $j + 1
		WEnd
;~ 	Else
;~ 		while 1
;~ 			Local $Line = FileReadLine($In2Handle)
;~ 			If @error Then ExitLoop
;~ 			If $usercancel = "true" Then ExitLoop
;~ 			If $closebuttonstatus = "true" Then ExitLoop
;~ 				_GUICtrlCreateListViewItem($Line, $searchlistView)
;~ 			$j = $j + 1
;~ 		WEnd
	;_ResetLockWait2()
	FileClose($In2Handle)
	;===========================================================================================================
	Opt("GUIOnEventMode", 0)
	If $closebuttonstatus = "true" Then
		GUIDelete($searchGUI)
		GUISetState(@SW_SHOW, $mainGUI)
		Return 0
	EndIf
	$finaltimedifference = TimerDiff($searchbegin)
	$minutes = Floor($finaltimedifference / 60000)
	$seconds = Round((($finaltimedifference / 60000) - Floor($finaltimedifference / 60000)) * 60, 2)
	GUICtrlSetData($timestatuslabel,"Took " & $minutes & " mins:" & $seconds & " secs to complete the search.")
	GUICtrlSetData($statuslabel2, "")
	GUICtrlSetData($statuslabel2, "Done!  Found " & $j & " files after searching through " & $masterfilecounter & " files total.")
	GUICtrlSetData ( $stopbutton,"Open")
	WinSetTitle("Searching... (Esc cancels)", "", "Search Results")
	HotKeySet("{Esc}")
;~ 	ConsoleWrite(@CRLF &_GUICtrlListViewGetSubItemsCount ($searchlistView))
	$numberofcolumns = _GUICtrlListViewGetSubItemsCount ($searchlistView)
	_ReduceMemory()
	$timerstamp = TimerInit()
	While 1
;~ 		$current = _GUICtrlListViewGetHotItem ($searchlistView)
		$msg = GUIGetMsg()
		Select
			Case $msg = $GUI_EVENT_CLOSE
				GUIDelete($searchGUI)
				;_ArrayDelete()
				_GUIListViewClose()
				GUISetState(@SW_SHOW, $mainGUI)
				ExitLoop
			Case $msg = $openbutton
				Local $a_indices = _GUICtrlListViewGetSelectedIndices ($searchlistView, 1)
				If (IsArray($a_indices)) Then
					Local $i2
					For $i2 = 1 To $a_indices[0]
						$a_Item = _GUICtrlListViewGetItemTextArray ($searchlistView, $a_indices[$i2])
						If (Not IsArray($a_Item)) Then _RunDOS("@Start " & FileGetShortName($a_Item[2]));$a_Item[2] &
					Next
				EndIf
			Case $msg = $fileitemOpen
				Local $a_indices = _GUICtrlListViewGetSelectedIndices ($searchlistView, 1)
				If (IsArray($a_indices)) Then
					Local $i2
					For $i2 = 1 To $a_indices[0]
						$a_Item = _GUICtrlListViewGetItemTextArray ($searchlistView, $a_indices[$i2])
						If  IsArray($a_Item) Then _RunDOS("@Start " & FileGetShortName( $a_Item[2]));$a_Item[2] &
					Next
				EndIf
		EndSelect
		Select
			Case $msg = $GUI_EVENT_PRIMARYDOWN
				$pos = GUIGetCursorInfo()
				If ($pos[4] == $searchlistView) Then
					If (TimerDiff($timerstamp) / 1000 > 2 And _GUICtrlListViewGetHotItem ($searchlistView) >= 0) Then
						$current = _GUICtrlListViewGetHotItem ($searchlistView)
						$timerstamp = TimerInit()
					ElseIf ($current = _GUICtrlListViewGetHotItem ($searchlistView) And _GUICtrlListViewGetHotItem ($searchlistView) >= 0) Then
						If TimerDiff($timerstamp) / 1000 <= 2 Then
							Run("explorer.exe /select, " & FileGetShortName(_GUICtrlListViewGetItemText ($searchlistView, $current, 1) ), "", @SW_MAXIMIZE)
						EndIf
					EndIf
				EndIf
			Case $msg = $searchlistView
				;_LockAndWait2()
				__GUICtrlListViewSort ($searchlistView, $B_DESCENDING, GUICtrlGetState($searchlistView))
				;_ResetLockWait2()
		EndSelect
	WEnd
EndFunc   ;==>StartSearch
func _Search_VBSText($sfile,$sDumpFiletemp,$searchquierie) ; Output file must be re-read and re-written, else only has"LF" not "CRLF", so not easily read again
	;$sDumpFiletemp=@ScriptDir&"\temp.txt"; Output; quickest easily available is vscript??.. Can we do it with dos?
	FileDelete($sDumpFiletemp)
	$s_Quotes='"' ;    "&$s_Quotes&"
	$code= "Function FileWriter()";,WriteFile,Query)"
	;$code &= @LF & "ReadFile="&$s_Quotes&"c:\Programs\Searchengine\AnsSorted.txt"&$s_Quotes
	$code &= @LF & "ReadFile="&$s_Quotes&$sfile&$s_Quotes
	$code &= @LF & "WriteFile="&$s_Quotes&$sDumpFiletemp&$s_Quotes
	$code &= @LF & "Query="&$s_Quotes&$searchquierie&$s_Quotes
	$code &= @LF & "Dim objFileSystem: Set objFileSystem = CreateObject( "&$s_Quotes&"Scripting.FileSystemObject"&$s_Quotes&") "
	$code &= @LF & "Dim fso, fso1,f1, InFile, ReadString,s_Dirs"
	$code &= @LF & "Set f1 = objFileSystem.CreateTextFile(WriteFile, True)"
	$code &= @LF & "Set InFile = objFileSystem.OpenTextFile(ReadFile, 1)"
	$code &= @LF & "'for count=1 to 5"
	$code &= @LF & "Do While Not InFile.AtEndOfStream"
	$code &= @LF & "Line = InFile.ReadLine"
	$code &= @LF & "		i_Pos= instr(1,Line, "&$s_Quotes&"|"&$s_Quotes&",1)"
	$code &= @LF & "		ARsplitLine=split(Line, "&$s_Quotes&"|"&$s_Quotes&")"
	$code &= @LF & "		fileName=ARsplitLine(0)"
	$code &= @LF & "		FolderName=ARsplitLine(1)"
	$code &= @LF & "		if instr(1,FolderName, Query,1) then"
	$code &= @LF & "			If not (instr(1,s_Dirs,FolderName,1)>0) Then"
	$code &= @LF & "					f1.WriteLine FolderName&Mid(Line,i_Pos)"
	$code &= @LF & "				s_Dirs=s_Dirs&FolderName"
	$code &= @LF & "			End If"
	$code &= @LF & "		End If"
	$code &= @LF & "		if instr(1,fileName, Query,1) then"
	$code &= @LF & "					f1.WriteLine Line"
	$code &= @LF & "		End If"
	$code &= @LF & "'next"
	$code &= @LF & "Loop"
	$code &= @LF & "InFile.Close"
	$code &= @LF & "f1.Close"
	$code &= @LF & "end Function"
;~ 	ConsoleWrite($code)
	$vbs = ObjCreate("ScriptControl")
	$vbs.language="vbscript"
	$vbs.addcode($code)
	;$retour =
	$vbs.run("FileWriter");,$sDumpFiletemp,$searchquierie)
	$vbs=""
EndFunc   ;==>_Search_VBSText
;===================================================
Func CMDIndex()
	$nTimerQuery = TimerInit()
	If @Compiled = 1 Then
		ProcessSetPriority(@ScriptName, 0)
	EndIf
	HotKeySet("{Esc}", "Cancel")
	$indexoutput = ""
	$usercancel = "false"
	$begin3 = TimerInit()
	GUISetState(@SW_HIDE, $mainGUI)
	$indexingGUI = GUICreate("Indexing... (Esc cancels)", 300, 50, (@DesktopWidth - 300) / 2, (@DesktopHeight - 50) / 2)
	$indexingLabel=GUICtrlCreateLabel("Indexing.  This may take a while.  Please Wait...", 30, 1, 250, 25)
	$indexstatuslabel = GUICtrlCreateLabel("", 20, 25, 280, 20)
	GUISetState()
	$filecounter = 0
	$s_DriveTypes=_iif(GUICtrlRead($DrivesAll)>1,"FIXED","ALL")
	$fixeddrives = DriveGetDrive( $s_DriveTypes)
	$readdrivecomboindex = GUICtrlRead($drivecomboindex)
	if $readdrivecomboindex=="ALL Drives" then $readdrivecomboindex=$s_DriveTypes&" Drives"
	If Not @error Then
		GUICtrlSetData($drivecomboindex, "", $s_DriveTypes&" Drives")
		GUICtrlSetData($drivecomboindex, $s_DriveTypes&" Drives", $s_DriveTypes&" Drives")
		GUICtrlSetData($drivecomboindex, $readdrivecomboindex, $readdrivecomboindex)
		For $i = 1 To ubound($fixeddrives)-1
			GUICtrlSetData($drivecombo, StringUpper($fixeddrives[$i]), $readdrivecomboindex)
			GUICtrlSetData($drivecomboindex, StringUpper($fixeddrives[$i]),$readdrivecomboindex)
		Next
		GUICtrlSetData($drivecombo, "ALL Drives", "ALL Drives")
	EndIf
	If $readdrivecomboindex = $s_DriveTypes&" Drives" Then
		If Not @error Then
			For $drivenumber = 1 To ubound($fixeddrives)-1
				If $usercancel = "true" Then ExitLoop
				$drive = $fixeddrives[$drivenumber]
				_SingleDriveIndex ()
				If $usercancel = "true" Then ExitLoop
			Next
		EndIf
	Else
		$drive = $readdrivecomboindex
		_SingleDriveIndex ()
	EndIf
	If @Compiled = 1 Then
		ProcessSetPriority(@ScriptName, 2)
	EndIf
	GUISetState(@SW_HIDE, $indexingGUI)
	GUISetState(@SW_SHOW, $mainGUI)
	HotKeySet("{Esc}")
	If $usercancel = "true" Then
		MsgBox(0, "Cancelled", "The indexing has been cancelled.")
	Else
		$finaltimedifference = TimerDiff($begin3)
		$minutes = Floor($finaltimedifference / 60000)
		$seconds = Round((($finaltimedifference / 60000) - Floor($finaltimedifference / 60000)) * 60, 0)
		MsgBox(0, "Done", "Done Creating the Index.  It took " & $minutes & " minutes and " & $seconds & " seconds.")
	EndIf
	ConsoleWrite('@@ Debug(681) : ' & "NewEng" & "=" & Round(TimerDiff($nTimerQuery), 2) & " MSEC." & @LF) ;### Debug Console
EndFunc   ;==>CMDIndex
Func _SingleDriveIndex ()
	Local $s_Prepare,$s_AnswerFileFinal=@ScriptDir&"\AnsFinal.txt",$s_AnswerFile=@ScriptDir&"\AnsFullPath.txt"
	Local 	$s_AnswerFile2=@ScriptDir&"\AnsInfo.txt",$s_AnswerFile3=@ScriptDir&"\AnsInfoMOD.txt"
	Local 	$s_AnswerFileSorted=@ScriptDir&"\AnsSorted.txt"
	Local $s_CurrentFile
	;============================================================================Step 1 of 6
	GUICtrlSetData($indexstatuslabel, "Reading Files on Drive " & StringUpper($drive) & " Step 1 of 6")
	$begin = TimerInit()
	$s_Checker=FileFindFirstFile($drive&"\*")
	If $s_Checker = -1 or not FileExists($drive&"\") Then  return
	;ConsoleWrite("Time to cmd index:"&TimerDiff($begin) / 1000)
	If $usercancel = "true" Then Return
	;writes the output to the file
	$sTimeStamp=TimerInit()
	;============================================================================Step 3 of 6
	GUICtrlSetData($indexstatuslabel, "Writing Index for Drive " & StringUpper($drive) & " to Memory - Step 3 of 6")
	$begin = TimerInit()
	GUICtrlSetData($indexstatuslabel, "Writing Index to File for Drive " & StringUpper($drive) & " Step 6 of 6")
	$filepath = @ScriptDir & "\"&$s_ComputerName&"FastSearch_DBtitle" & StringTrimRight($drive, 1) & ".index"
	$s_MasterIndex=@ScriptDir & "\"&$s_ComputerName&"FastSearch_DBmasterindex" & StringTrimRight($drive, 1) & ".index"
	_FileCreate($s_MasterIndex)
	_FileCreate($filepath)
	$sFile = @ScriptDir & "\"&$s_ComputerName&"FastSearch_"& StringUpper(StringTrimRight($drive, 1))&"_.txt"
	$n1TimerQuery = TimerInit()
	;GUICtrlSetData($indexingLabel,"Now creating text file by DOS Directory x1")
	;===========================================================================================================
	_DosIndex($sFile,$s_AnswerFile,$s_AnswerFile2,$s_AnswerFile3,$s_AnswerFileSorted)
	;===========================================================================================================
	;GUICtrlSetData($indexingLabel,"Now importing CSV text file to SQLite DB")
	;===========================================================================================================
	ConsoleWrite("Time :"&TimerDiff($begin) / 1000& " seconds to compile the array.")
EndFunc   ;==>_SingleDriveIndex 
Func _DosIndex($s_AnswerFileFinal,$s_AnswerFile,$s_AnswerFile2,$s_AnswerFile3,$s_AnswerFileSorted)
	$DTimerQuery = TimerInit()
	_FileCreate(@ScriptDir&"\AnsFullPath.txt")
	_FileCreate(@ScriptDir&"\AnsInfo.txt")
	_FileCreate(@ScriptDir&"\AnsInfoMOD.txt")
	_FileCreate(@ScriptDir&"\AnsFinal.txt")
	_FileCreate(@ScriptDir&"\AnsSorted.txt")
	;MsgBox(0,"b4 dos","FileGetSize($s_AnswerFile)="&FileGetSize($s_AnswerFile))
	$s_AnswerFile=FileGetShortName($s_AnswerFile)
	$s_AnswerFile2=FileGetShortName($s_AnswerFile2)
	$s_AnswerFile3=FileGetShortName($s_AnswerFile3)
	;$s_AnswerFileFinal=FileGetShortName($s_AnswerFileFinal)
	$s_AnswerFileSorted=FileGetShortName($s_AnswerFileSorted); \* /s/b /On /-C/a-d-h-s
	$sCommand=	" dir " & $drive & "\* /s/b /On /-C/a-d-h-s>" &  $s_AnswerFile& _
			"|dir " & $drive & "\* /s   /TC/On /-C/a-d-h-s| FIND "&'"/"'&"> " &  $s_AnswerFile2& _
			"|dir " & $drive & "\* /s   /TW/On /-C/a-d-h-s| FIND "&'"/"'&"> " &  $s_AnswerFile3 ; only lines with "AM" or "PM" [find "M"]
	ConsoleWrite($sCommand&@CRLF)
	$i_Pid=RunWait (@ComSpec & " /c " & $sCommand, @WorkingDir, @SW_HIDE)
	ProcessClose($i_Pid)
	ConsoleWrite('@@ Debug(DOS) : ' & "$sDbTableIndexSearch"  & "=" & Round(TimerDiff($DTimerQuery), 2) & " MSEC." & @LF ) ;### Debug Console
	;RunWait ("notepad " & $s_AnswerFile2)
	ConsoleWrite("completed "&@ScriptName&"="&Round(TimerDiff($DTimerQuery)/1000, 2) &@LF)
	;MsgBox(0,"","FileGetSize($s_AnswerFile)="&FileGetSize($s_AnswerFile))
	while not FileGetSize($s_AnswerFile)
		sleep(50)
	wend
	;sleep(1000)
	$Count1=_FileCountLines($s_AnswerFile)
	$Count2=_FileCountLines($s_AnswerFile2)
	$Count3=_FileCountLines($s_AnswerFile3)
	if $Count1<>$Count2 or $Count1<>$Count3 then
		MsgBox(0,"","Error=$Count1<>$Count2 etc")
	Else
		;exit
		;MsgBox(0,"b4 parse","FileGetSize($s_AnswerFile)="&FileGetSize($s_AnswerFile))
		_ParseIndex($s_AnswerFileFinal,$s_AnswerFile,$s_AnswerFile2,$s_AnswerFile3,$s_AnswerFileSorted)
		;MsgBox(0,"","FileGetSize($s_AnswerFile)="&FileGetSize($s_AnswerFile))
		;MsgBox(0,"outside","$s_AnswerFileFinal="&$s_AnswerFileFinal)
		while not FileGetSize($s_AnswerFileFinal)
			sleep(50)
		wend
		;sleep(1000)
		;RunWait ("notepad " & $s_AnswerFileFinal)
		;_ParseIndexAU($s_AnswerFileFinal,$s_AnswerFile,$s_AnswerFile2,$s_AnswerFile3,$s_AnswerFileSorted)
	EndIf
	$nTimerQuery = TimerInit()
	ConsoleWrite("completed "&@ScriptName&"="&Round(TimerDiff($nTimerQuery)/1000, 2) &@LF)
EndFunc   ;==>_DosIndex
Func _ParseIndexOLD2( $s_AnswerFileFinal,$s_AnswerFile,$s_AnswerFile2,$s_AnswerFile3,$s_AnswerFileSorted)
	$n1TimerQuery = TimerInit()
	;FileDelete($s_AnswerFileFinal)
	if FileExists($s_AnswerFileFinal) then
		while not FileDelete($s_AnswerFileFinal)
			sleep(50)
		wend
		;sleep(1000)
	EndIf
	$s_Quotes='"' ;    "&$s_Quotes&"
	;MsgBox(0,"inside","$s_AnswerFileFinal="&$s_AnswerFileFinal)
	$code= "Function FileWrite()";,WriteFile,Query)"
	;$code &= @LF & "ReadFile="&$s_Quotes&"c:\Programs\Searchengine\AnsSorted.txt"&$s_Quotes
	$code &= @LF & 's_AnswerFile="'&$s_AnswerFile&'"'
	$code &= @LF & 's_AnswerFile2="'&$s_AnswerFile2&'"'
	$code &= @LF & 's_AnswerFile3="'&$s_AnswerFile3&'"'
	$code &= @LF & 's_AnswerFileFinal="'&$s_AnswerFileFinal&'"'
	$code &= @LF & 'Dim objFileSystem: Set objFileSystem = CreateObject( "Scripting.FileSystemObject") '
	$code &= @LF & 'Dim fso, fso1,f1, InFile, ReadString,s_Dirs,Time2,Time3'
	$code &= @LF & 'Set hWriteFile = objFileSystem.CreateTextFile(s_AnswerFileFinal, True)'
	$code &= @LF & 'Set hReadFile1 = objFileSystem.OpenTextFile(s_AnswerFile, 1)'
	$code &= @LF & 'Set hReadFile2 = objFileSystem.OpenTextFile(s_AnswerFile2, 1)'
	$code &= @LF & 'Set hReadFile3 = objFileSystem.OpenTextFile(s_AnswerFile3, 1)'
	$code &= @LF & 'Do While Not hReadFile1.AtEndOfStream'
	$code &= @LF & 's_LineFrom1 = hReadFile1.ReadLine'
	$code &= @LF & 's_LineFrom2 = hReadFile2.ReadLine'
	$code &= @LF & 's_LineFrom3 = hReadFile3.ReadLine'
	;========================here
	;	$code &= @LF & '		i_Pos= instr(1,Line, "|",1)';(s_LineFrom1,"\",0,-1)'
	$code &= @LF & 'i_pos=InStrRev(s_LineFrom1, "\")'
	$code &= @LF & 's_NamePath=Left(s_LineFrom1,i_pos)'
	$code &= @LF & 's_Name1=Mid(s_LineFrom1,i_pos+1)'
	$code &= @LF & 'i_posDot=instr(s_LineFrom1, ".")'
	$code &= @LF & 's_Ext=""'
	$code &= @LF & 'if i_posDot then s_Ext=Mid(s_LineFrom1,i_posDot+1)'
	$code &= @LF & 'if instr(s_Ext,"\") then s_Ext=""'
	$code &= @LF & 'Size=round(mid(s_LineFrom3,21,19)/1024,2)'
	;$code &= @LF & 'Time2=Left(s_LineFrom2,10)&replace(mid(s_LineFrom2,19,2)&mid(s_LineFrom2,12,6),"AM 12","AM 00")'
	$code &= @LF & 'Time2=mid(s_LineFrom2,7,4)&mid(s_LineFrom2,3,4)&Left(s_LineFrom2,2)&" "&replace(mid(s_LineFrom2,19,2)&mid(s_LineFrom2,12,6),"AM 12","AM 00")'
	$code &= @LF & 'Time3=mid(s_LineFrom3,7,4)&mid(s_LineFrom3,3,4)&Left(s_LineFrom3,2)&" "&replace(mid(s_LineFrom3,19,2)&mid(s_LineFrom3,12,6),"AM 12","AM 00")'
	;$code &= @LF & 'hWriteFile.WriteLine s_Name1&"|"&s_NamePath&"|"&Size&"|"&Left(s_LineFrom2,20)&"|"&Left(s_LineFrom3,20)&"|"&s_Ext'
	$code &= @LF & 'hWriteFile.WriteLine s_Name1&"|"&s_NamePath&"|"&Size&"|"&Time2&"|"&Time3&"|"&s_Ext'
	$code &= @LF & 'Loop'
	$code &= @LF & 'hWriteFile.Close'
	$code &= @LF & 'hReadFile3.Close'
	$code &= @LF & 'hReadFile2.Close'
	$code &= @LF & 'hReadFile1.Close'
	$code &= @LF & 'end Function'
;~ 	ConsoleWrite($code)
	$vbs = ObjCreate("ScriptControl")
	$vbs.language="vbscript"
	$vbs.addcode($code)
	;$retour =
	$vbs.run("FileWrite");,$sDumpFiletemp,$searchquierie)
	$vbs=""
	;if not $s_AnswerFileFinal=@ScriptDir&"\AnsFinal.txt" then
	;	FileCopy($s_AnswerFileFinal,@ScriptDir&"\AnsFinal.txt",1)
	;$s_AnswerFileFinal=@ScriptDir&"\AnsFinal.txt"
	;EndIf
	;MsgBox(0,"at end loop","$s_AnswerFileFinal="&$s_AnswerFileFinal)
	ConsoleWrite("end DOS "&@ScriptName&"="&Round(TimerDiff($n1TimerQuery)/1000, 2)&@LF )
EndFunc   ;==>_ParseIndex
Func _ParseIndex( $s_AnswerFileFinal,$s_AnswerFile,$s_AnswerFile2,$s_AnswerFile3,$s_AnswerFileSorted)
	$n1TimerQuery = TimerInit()
	local $i_InternationalDate=0,$i_AMPM=0
	;FileDelete($s_AnswerFileFinal)

	if FileExists($s_AnswerFileFinal) then
		while not FileDelete($s_AnswerFileFinal)
			sleep(50)
		wend
		;sleep(1000)
	EndIf
	;=============================================
	$h_File=FileOpen($s_AnswerFile2,0)
	$s_Line=FileReadLine($h_File)
	;if not @error then 
	if StringInStr($s_Line," AM ") or StringInStr($s_Line," PM ") then $i_AMPM=1 
	;EndIf
	FileClose($h_File)
	$s_Xmas_Date=_DateTimeFormat ( "2006/12/25", 2)
	if StringLeft($s_Xmas_Date,2)="25" then $i_InternationalDate=1
	;MsgBox(0,"","$i_InternationalDate="&$i_InternationalDate)
	
	;=============================================
	$s_Quotes='"' ;    "&$s_Quotes&"
	;MsgBox(0,"inside","$s_AnswerFileFinal="&$s_AnswerFileFinal)
	$code= "Function FileWrite()";,WriteFile,Query)"
	;$code &= @LF & "ReadFile="&$s_Quotes&"c:\Programs\Searchengine\AnsSorted.txt"&$s_Quotes
	$code &= @LF & 's_AnswerFile="'&$s_AnswerFile&'"'
	$code &= @LF & 's_AnswerFile2="'&$s_AnswerFile2&'"'
	$code &= @LF & 's_AnswerFile3="'&$s_AnswerFile3&'"'
	$code &= @LF & 's_AnswerFileFinal="'&$s_AnswerFileFinal&'"'
	$code &= @LF & 'Dim objFileSystem: Set objFileSystem = CreateObject( "Scripting.FileSystemObject") '
	$code &= @LF & 'Dim fso, fso1,f1, InFile, ReadString,s_Dirs,Time2,Time3'
	$code &= @LF & 'Set hWriteFile = objFileSystem.CreateTextFile(s_AnswerFileFinal, True)'
	$code &= @LF & 'Set hReadFile1 = objFileSystem.OpenTextFile(s_AnswerFile, 1)'
	$code &= @LF & 'Set hReadFile2 = objFileSystem.OpenTextFile(s_AnswerFile2, 1)'
	$code &= @LF & 'Set hReadFile3 = objFileSystem.OpenTextFile(s_AnswerFile3, 1)'
	$code &= @LF & 'Do While Not hReadFile1.AtEndOfStream'
	$code &= @LF & 's_LineFrom1 = hReadFile1.ReadLine'
	$code &= @LF & 's_LineFrom2 = hReadFile2.ReadLine'
	$code &= @LF & 's_LineFrom3 = hReadFile3.ReadLine'
	;========================here
	;	$code &= @LF & '		i_Pos= instr(1,Line, "|",1)';(s_LineFrom1,"\",0,-1)'
	$code &= @LF & 'i_pos=InStrRev(s_LineFrom1, "\")'
	$code &= @LF & 's_NamePath=Left(s_LineFrom1,i_pos)'
	$code &= @LF & 's_Name1=Mid(s_LineFrom1,i_pos+1)'
	$code &= @LF & 'i_posDot=instr(s_LineFrom1, ".")'
	$code &= @LF & 's_Ext=""'
	$code &= @LF & 'if i_posDot then s_Ext=Mid(s_LineFrom1,i_posDot+1)'
	$code &= @LF & 'if instr(s_Ext,"\") then s_Ext=""'
	$code &= @LF & 'Size=round(mid(s_LineFrom3,21,19)/1024)'
	;$code &= @LF & 'Time2=Left(s_LineFrom2,10)&replace(mid(s_LineFrom2,19,2)&mid(s_LineFrom2,12,6),"AM 12","AM 00")'
	$s_Time='&mid(s_LineFrom2,12,6)'
	if  $i_AMPM then $s_Time='&replace(mid(s_LineFrom2,19,2)&mid(s_LineFrom2,12,6),"AM 12","AM 00")'
	if not $i_InternationalDate then 	$code &= @LF & 'Time2=mid(s_LineFrom2,7,4)&"/"&Left(s_LineFrom2,3)&mid(s_LineFrom2,4,2)&" "'&$s_Time
	if  $i_InternationalDate then 		$code &= @LF & 'Time2=mid(s_LineFrom2,7,4)&mid(s_LineFrom2,3,4)&Left(s_LineFrom2,2)&" "'&$s_Time
	if not $i_InternationalDate then 	$code &= @LF & 'Time3=mid(s_LineFrom2,7,4)&"/"&Left(s_LineFrom2,3)&mid(s_LineFrom2,4,2)&" "'&$s_Time
	if  $i_InternationalDate then 		$code &= @LF & 'Time3=mid(s_LineFrom3,7,4)&mid(s_LineFrom3,3,4)&Left(s_LineFrom3,2)&" "'&$s_Time
	;$code &= @LF & 'hWriteFile.WriteLine s_Name1&"|"&s_NamePath&"|"&Size&"|"&Left(s_LineFrom2,20)&"|"&Left(s_LineFrom3,20)&"|"&s_Ext'
	$code &= @LF & 'hWriteFile.WriteLine s_Name1&"|"&s_NamePath&"|"&Size&"|"&Time2&"|"&Time3&"|"&s_Ext'
	$code &= @LF & 'Loop'
	$code &= @LF & 'hWriteFile.Close'
	$code &= @LF & 'hReadFile3.Close'
	$code &= @LF & 'hReadFile2.Close'
	$code &= @LF & 'hReadFile1.Close'
	$code &= @LF & 'end Function'
;~ 	ConsoleWrite($code)
	$vbs = ObjCreate("ScriptControl")
	$vbs.language="vbscript"
	$vbs.addcode($code)
	;$retour =
	$vbs.run("FileWrite");,$sDumpFiletemp,$searchquierie)
	$vbs=""
	;if not $s_AnswerFileFinal=@ScriptDir&"\AnsFinal.txt" then
	;	FileCopy($s_AnswerFileFinal,@ScriptDir&"\AnsFinal.txt",1)
	;$s_AnswerFileFinal=@ScriptDir&"\AnsFinal.txt"
	;EndIf
	;MsgBox(0,"at end loop","$s_AnswerFileFinal="&$s_AnswerFileFinal)
	ConsoleWrite("end DOS "&@ScriptName&"="&Round(TimerDiff($n1TimerQuery)/1000, 2)&@LF )
EndFunc   ;==>_ParseIndex
Func _ParseIndexOLD( $s_AnswerFileFinal,$s_AnswerFile,$s_AnswerFile2,$s_AnswerFile3,$s_AnswerFileSorted)
	$n1TimerQuery = TimerInit()
	;FileDelete($s_AnswerFileFinal)
	if FileExists($s_AnswerFileFinal) then
		while not FileDelete($s_AnswerFileFinal)
			sleep(50)
		wend
		;sleep(1000)
	EndIf
	$s_Quotes='"' ;    "&$s_Quotes&"
	;MsgBox(0,"inside","$s_AnswerFileFinal="&$s_AnswerFileFinal)
	$code= "Function FileWrite()";,WriteFile,Query)"
	;$code &= @LF & "ReadFile="&$s_Quotes&"c:\Programs\Searchengine\AnsSorted.txt"&$s_Quotes
	$code &= @LF & "s_AnswerFile="&$s_Quotes&$s_AnswerFile&$s_Quotes
	$code &= @LF & "s_AnswerFile2="&$s_Quotes&$s_AnswerFile2&$s_Quotes
	$code &= @LF & "s_AnswerFile3="&$s_Quotes&$s_AnswerFile3&$s_Quotes
	$code &= @LF & "s_AnswerFileFinal="&$s_Quotes&$s_AnswerFileFinal&$s_Quotes
	$code &= @LF & "Dim objFileSystem: Set objFileSystem = CreateObject( "&$s_Quotes&"Scripting.FileSystemObject"&$s_Quotes&") "
	$code &= @LF & "Dim fso, fso1,f1, InFile, ReadString,s_Dirs"
	$code &= @LF & "Set hWriteFile = objFileSystem.CreateTextFile(s_AnswerFileFinal, True)"
	$code &= @LF & "Set hReadFile1 = objFileSystem.OpenTextFile(s_AnswerFile, 1)"
	$code &= @LF & "Set hReadFile2 = objFileSystem.OpenTextFile(s_AnswerFile2, 1)"
	$code &= @LF & "Set hReadFile3 = objFileSystem.OpenTextFile(s_AnswerFile3, 1)"
	$code &= @LF & "Do While Not hReadFile1.AtEndOfStream"
	$code &= @LF & "s_LineFrom1 = hReadFile1.ReadLine"
	$code &= @LF & "s_LineFrom2 = hReadFile2.ReadLine"
	$code &= @LF & "s_LineFrom3 = hReadFile3.ReadLine"
	;========================here
	;	$code &= @LF & "		i_Pos= instr(1,Line, "&$s_Quotes&"|"&$s_Quotes&",1)"
	$code &= @LF & "i_pos=InStrRev(s_LineFrom1, "&$s_Quotes&"\"&$s_Quotes&")'(s_LineFrom1,"&$s_Quotes&"\"&$s_Quotes&",0,-1)"
	$code &= @LF & "s_NamePath=Left(s_LineFrom1,i_pos)"
	$code &= @LF & "s_Name1=Mid(s_LineFrom1,i_pos+1)"
	$code &= @LF & "i_posDot=instr(s_LineFrom1, "&$s_Quotes&"."&$s_Quotes&")"
	$code &= @LF & "s_Ext="&$s_Quotes&""&$s_Quotes
	$code &= @LF & "if i_posDot then s_Ext=Mid(s_LineFrom1,i_posDot+1)"
	$code &= @LF & "if instr(s_Ext,"&$s_Quotes&"\"&$s_Quotes&") then s_Ext="&$s_Quotes&""&$s_Quotes
	$code &= @LF & "Size=round(mid(s_LineFrom3,21,19)/1024,2)"
	$code &= @LF & "hWriteFile.WriteLine s_Name1&"&$s_Quotes&"|"&$s_Quotes&"&s_NamePath&"&$s_Quotes&"|"&$s_Quotes&"&Size&"&$s_Quotes&"|"&$s_Quotes&"&Left(s_LineFrom2,20)&"&$s_Quotes&"|"&$s_Quotes&"&Left(s_LineFrom3,20)&"&$s_Quotes&"|"&$s_Quotes&"&s_Ext"
	$code &= @LF & "Loop"
	$code &= @LF & "hWriteFile.Close"
	$code &= @LF & "hReadFile3.Close"
	$code &= @LF & "hReadFile2.Close"
	$code &= @LF & "hReadFile1.Close"
	$code &= @LF & "end Function"
;~ 	ConsoleWrite($code)
	$vbs = ObjCreate("ScriptControl")
	$vbs.language="vbscript"
	$vbs.addcode($code)
	;$retour =
	$vbs.run("FileWrite");,$sDumpFiletemp,$searchquierie)
	$vbs=""
	;if not $s_AnswerFileFinal=@ScriptDir&"\AnsFinal.txt" then
	;	FileCopy($s_AnswerFileFinal,@ScriptDir&"\AnsFinal.txt",1)
	;$s_AnswerFileFinal=@ScriptDir&"\AnsFinal.txt"
	;EndIf
	;MsgBox(0,"at end loop","$s_AnswerFileFinal="&$s_AnswerFileFinal)
	ConsoleWrite("end DOS "&@ScriptName&"="&Round(TimerDiff($n1TimerQuery)/1000, 2)&@LF )
EndFunc   ;==>_ParseIndex
;===================================================
Func Cancel()
	;used in the event that a user presses Escape while the search engine is running or while the indexing engine is running.
	;checks to make sure the user is pressing cancel for the search engine and not for some other program that have open while the search engine is running
	If WinActive("Searching... (Esc cancels)") Then
		$answer = MsgBox(292, "Cancel?", "Are you sure you want to cancel the search?")
		If $answer = 6 Then
			$usercancel = "true"
			HotKeySet("{Esc}")
		EndIf
		;checks to make sure the user is pressing cancel for the indexing engine and not for some other program that have open while the indexing engine is running
	ElseIf WinActive("Indexing... (Esc cancels)") Then
		$answer = MsgBox(292, "Cancel?", "Are you sure you want to cancel the index?  All index progress will be lost.")
		If $answer = 6 Then
			$usercancel = "true"
			WinSetTitle("Indexing... (Esc cancels)", "", "Cancelling Index...")
			GUICtrlSetData($indexmainlabel, "Cancelling Index.  Please wait...")
			GUICtrlSetData($indexstatuslabel, "Locating and removing temporary files...")
			HotKeySet("{Esc}")
		EndIf
	Else
		HotKeySet("{Esc}")
		Send("{Esc}")
		HotKeySet("{Esc}", "Cancel")
	EndIf
EndFunc   ;==>Cancel
Func Error()
	;i wrote this in case the program encounters an error.  I was hoping this error message would be friendly than the "AUTO IT ERROR LINE 165 "fileClose()" blah blah"
	MsgBox(4112, "Error!", "An error has occured and the Search/Indexing Engine must close.")
	Exit
EndFunc   ;==>Error
Func SpecialEvents()
	Select
		Case @GUI_CtrlId = $GUI_EVENT_CLOSE
			$closebuttonstatus = "true"
		Case @GUI_CtrlId = $GUI_EVENT_MINIMIZE
			WinSetState("Searching...", "", @SW_MINIMIZE)
		Case @GUI_CtrlId = $GUI_EVENT_RESTORE
			WinSetState("Searching...", "", @SW_RESTORE)
	EndSelect
EndFunc   ;==>SpecialEvents
Func ListViewClicked()
	__GUICtrlListViewSort ($searchlistView, $B_DESCENDING, GUICtrlGetState($searchlistView))
EndFunc   ;==>ListViewClicked
Func PrimaryDown()
	$pos = GUIGetCursorInfo()
	If ($pos[4] == $searchlistView) Then
		If (TimerDiff($timerstamp) / 1000 > 2 And _GUICtrlListViewGetHotItem ($searchlistView) >= 0) Then
			;msgbox("", "Hot Item:" , _GUICtrlListViewGetHotItem ($searchlistView))
			$current2 = _GUICtrlListViewGetHotItem ($searchlistView)
			;msgbox(0,"",_GUICtrlListViewGetItemText($searchlistView, $current, 1))
			$timerstamp = TimerInit()
		ElseIf ($current2 = _GUICtrlListViewGetHotItem ($searchlistView) And _GUICtrlListViewGetHotItem ($searchlistView) >= 0) Then
			If TimerDiff($timerstamp) / 1000 <= 2 Then
				Run("explorer.exe /select, " & FileGetShortName(_GUICtrlListViewGetItemText ($searchlistView, $current2, 1) & _GUICtrlListViewGetItemText ($searchlistView, $current2, 0)), "", @SW_MAXIMIZE)
			EndIf
		ElseIf (_GUICtrlListViewGetHotItem ($searchlistView == -1)) Then
			;msgbox("", "Hot Item:" , "None")
		EndIf
	EndIf
EndFunc   ;==>PrimaryDown
Func OpenPressed()
	Local $a_indices = _GUICtrlListViewGetSelectedIndices ($searchlistView, 1)
	If (IsArray($a_indices)) Then
		Local $i2
		For $i2 = 1 To $a_indices[0]
			;MsgBox(0,"Selected", $a_indices[$i2])
;~ 			_ArrayDisplay($a_indices, "K")
			$a_Item = _GUICtrlListViewGetItemTextArray ($searchlistView, $a_indices[$i2])
			If (Not IsArray($a_Item)) Then
				;GUICtrlSetData($Status, "Nothing Selected")
			Else
				;For $i = 1 To $a_Item[0]
				;	MsgBox(0, "Passed Item Index only", "SubItem[" & $i & "] = " & $a_Item[$i])
				;Next
;~ 				_ArrayDisplay($a_Item, "K")
				If UBound($a_Item) >= 3 Then
					_RunDOS("@Start " & FileGetShortName($a_Item[2] & $a_Item[1]))
				EndIf
			EndIf
		Next
	Else
		;GUICtrlSetData($Status, "Not Items Selected")
	EndIf
EndFunc   ;==>OpenPressed
Func StopPressed()
	$usercancel = "true"
EndFunc   ;==>StopPressed
Func terminate()
	ConsoleWrite(@CRLF &"Exiting...")
	GUIDelete($mainGUI)
	DirCreate(@TempDir & "\updatetmp")
	$intsuccess = InetGet("http://www.thekandieman.com/applications/updates/seversion.ini", @TempDir & "\updatetmp\seversion.ini", 1)
	ConsoleWrite(@CRLF &"Done downloading ini file.  intsuccess = "& $intsuccess)
	If $intsuccess = 0 Then
		ConsoleWrite(@CRLF & "Error, could not retrieve the file from the remote site.")
	Else
		ConsoleWrite(@CRLF &"Reading first ini file")
		$latestversion = IniRead(@TempDir & "\updatetmp\seversion.ini", "Version", "Latest Updater Version", "error")
		ConsoleWrite(@CRLF &"Done reading first ini and returned value = "& $latestversion)
		ConsoleWrite(@CRLF &"Reading second ini file")
		$currentversion = IniRead(@ScriptDir & "\version.ini", "Version", "Current Updater Version", "error")
		ConsoleWrite(@CRLF &"Done reading second ini and returned value = "& $currentversion)
		If $latestversion <> "error" Then
			If $latestversion <> $currentversion Then
				ConsoleWrite(@CRLF &"Starting download...")
				$intsuccess = InetGet("http://www.thekandieman.com/applications/updates/SEUpdate.dat",@TempDir & "\updatetmp\SEUpdate.exe",1)
				If $intsuccess <> 0 Then
					FileMove(@TempDir & "\updatetmp\SEUpdate.exe",@ScriptDir & "\SEUpdate.exe",1)
					ConsoleWrite(@CRLF & "Done, intsuccess = " & $intsuccess)
				Else
					ConsoleWrite(@CRLF & "Error, could not retrieve the remote file to update from off the server.")
				Endif
			Endif
		Endif
	Endif
	If FileExists(@TempDir & "\updatetmp\") Then
		DirRemove(@TempDir & "\updatetmp\", 1)
	EndIf
	Exit
EndFunc   ;==>terminate
Func _ReduceMemory()
	Local $ai_GetCurrentProcessId = DllCall('kernel32.dll', 'int', 'GetCurrentProcessId')
	Local $ai_Handle = DllCall("kernel32.dll", 'int', 'OpenProcess', 'int', 0x1f0fff, 'int', False, 'int', $ai_GetCurrentProcessId[0])
	Local $ai_Return = DllCall("psapi.dll", 'int', 'EmptyWorkingSet', 'long', $ai_Handle[0])
	DllCall('kernel32.dll', 'int', 'CloseHandle', 'int', $ai_Handle[0])
	Return $ai_Return[0]
EndFunc   ;==>_ReduceMemory
Func _FindLinesDOSsearchOLD(ByRef $s_file, ByRef $s_AnswerFile, $s_Searches, $i_Append = 0, $i_Case = 0, $i_Array = 0, $i_Literal = 0)
	;Syntax; _FindLinesDOSsearch($s_file,$s_AnswerFile,$s_Searches, $i_Case , $i_Array ,$i_Literal); $s_AnswerFile ByRef needs not be defined
	; Parameters; $i_Literal=1 implies spaces are delimiters for a number of search strings in $s_Searches, rather than spaces included in search
	Local $asList
	If FileExists($s_file) Then
		If $i_Append Then
			$i_Append = ">>"
		Else
			$i_Append = ">"
		EndIf
		If $i_Literal = 1 Then
			$i_Literal = "/c:"
		Else
			$i_Literal = ""
		EndIf
		If $i_Case = 1 Then
			$i_Case = "/I"
		Else
			$i_Case = ""
		EndIf
		$Position = StringInStr($s_file, "\", 0, -1)
		$s_Path = StringLeft($s_file, $Position)
		FileChangeDir($s_Path)
		;$s_AnswerFile = $s_Path & "AnswerFindLines.txt"
		$s_Searches = StringReplace($s_Searches, ".", "\."); to use as RegExp in "FindLines"
		$s_Searches = StringReplace($s_Searches, "*", ".*"); to use as RegExp in "FindLines"
		;$s_Searches = '"' & $s_Searches & '"'
		If StringInStr($s_file, " ") Then $s_file = '"' & $s_file & '"'
		If StringInStr($s_AnswerFile, " ") Then $s_AnswerFile = '"' & $s_AnswerFile & '"'
		;$s_Command = 'type | findstr /R' & $i_Case & ' ' & $i_Literal & $s_Searches & ' ' & $s_file &' ' & $i_Append & '  ' & $s_AnswerFile; rem /c: for literal?
		$s_Command = 'findstr /R' & $i_Case & ' ' & $i_Literal & $s_Searches & ' ' & $s_file &' ' & $i_Append & '  ' & $s_AnswerFile; rem /c: for literal?
		$i_Pid=RunWait(@ComSpec & " /c " & $s_Command, @ScriptDir, @SW_HIDE)
		ProcessClose($i_Pid)
		$s_AnswerFile = StringReplace($s_AnswerFile, '"', '')
		$s_file = StringReplace($s_file, '"', "")
		If $i_Array Then
			;FileReadToArray($s_AnswerFile, $asList)
			$sList = FileRead($s_AnswerFile, FileGetSize($s_AnswerFile))
			$sList = StringTrimRight(StringReplace($sList, @CRLF, @LF), 1)
			$asList = StringSplit($sList, @LF)
		EndIf
	Else
		SetError(1)
	EndIf
	;	while not FileGetSize($s_AnswerFile)
	;	sleep(50)
	;wend
	;FileCopy($s_AnswerFile,$s_AnswerFile_DosIndex,1)
	;		$s_Command = 'sort /+1/M/R  ' &$s_AnswerFile_DosIndex  & ' /O ' & $s_AnswerFile; rem /c: for literal?
	;		RunWait(@ComSpec & " /c " & $s_Command, @ScriptDir, @SW_HIDE)
	Return $asList
EndFunc   ;==>_FindLinesDOSsearchOLD
Func _LockAndWait2()
	Local $Cursor_WAIT
	GUISetState(@SW_LOCK)
	GUISetCursor($Cursor_WAIT, 1)
EndFunc   ;==>_LockAndWait2
Func _ResetLockWait2()
	Local $Cursor_ARROW
	GUISetState(@SW_UNLOCK)
	GUISetCursor($Cursor_ARROW, 1)
EndFunc   ;==>_ResetLockWait2