;#NoTrayIcon
#region startup
Opt("RunErrorsFatal", 0)
ObjEvent("AutoIt.Error", "Error")
#include <GuiConstants.au3>
#include <file.au3>
#include <Array.au3>
#Include <GuiListView.au3>
#include <process.au3>
#include <constants.au3>
Global $mainGUI, $s_AnswerFileSorted
Global $indexstatuslabel, $indexmainlabel
Global $number
Global $filetosave
Global $file
Global $filesize
Global $usercancel
Global $drive
Global $filearray
Global $filetosave = @ScriptDir & "\indexdata.index"
Global $searchquierie
Global $filetosavehandle
Global $filepath
Global $fixeddrives
Global $indexoutput
Global $indexinput
Global $fileoutput
Global $filecounter
Global $CurrentFile, $s_CurrentFile
Global $titleindex
Global $ExportFile
Global $closebuttonstatus
Global $nonarraymodifiedtimestamp;for listview when searching
Global $nonarraycreatedtimestamp;for listview when searching
Global $searchlistView ;so that it can be used by GUISETONEVENT functions
Global $B_DESCENDING[6] ;used for the number of columns in the search list view
Global $timerstamp ; a timerstamp used by the list view to determine if the user double clicked by finding the difference in time between the two clicks
Global $current2 ;used to determine the current object selected in the listview
Global $searchlisviewmenu ;so that it can be used by the GUISETONEVENT functions
Global $version = "1.5.1.9 build10"
IniWrite(@ScriptDir & "\version.ini", "Version", "Current Version", $version)
If FileExists(@ScriptDir & "\SEUpdate.exe") Then
	Run(@ComSpec & " /c " & "@start " & FileGetShortName(@ScriptDir & "\SEUpdate.exe"), "", @SW_HIDE)
EndIf
If $CmdLine[0] > 0 Then
	If $CmdLine[1] = "index" Then
		Exit
	EndIf
EndIf
$mainGUI = GUICreate("AutoIt Search Engine", 600, 300, (@DesktopWidth - 600) / 2, (@DesktopHeight - 300) / 2) ;$WS_OVERLAPPEDWINDOW + $WS_VISIBLE + $WS_CLIPSIBLINGS)
$lblasdf = GUICtrlCreateGroup("Search", 10, 40, 580, 110)
$Label_2 = GUICtrlCreateLabel("AutoIt Search Engine", 200, 10, 200, 30, $ES_CENTER)
$Label_4 = GUICtrlCreateLabel("A filename or part of a filename to search for:", 20, 70, 210, 20)
$searchquierieinput = GUICtrlCreateInput("", 250, 70, 310, 20)
$startsearchbutton = GUICtrlCreateButton("&Search", 245, 110, 100, 30)
$Group_6 = GUICtrlCreateGroup("Indexing", 10, 160, 580, 100)
$rebuildindexbutton = GUICtrlCreateButton("Rebuild Index", 260, 200, 80, 30)
$getindextime = GUICtrlCreateButton("&Get Index Date", 390, 200, 80, 30)
GUICtrlSetState($startsearchbutton, $GUI_DEFBUTTON)
GUICtrlSetFont($Label_2, 14)
GUICtrlCreateLabel("Search for files in:", 20, 113, 100, 30)
GUICtrlCreateLabel("Index the files in:", 60, 2113, 100, 30)
$drivecombo = GUICtrlCreateCombo("All Drives", 110, 110, 70, 30, $CBS_DROPDOWNLIST)
$drivecomboindex = GUICtrlCreateCombo("All Drives", 150, 210, 70, 30, $CBS_DROPDOWNLIST)
$fixeddrives = DriveGetDrive("FIXED")
If Not @error Then
	For $i = 1 To $fixeddrives[0]
		GUICtrlSetData($drivecombo, StringUpper($fixeddrives[$i]), "All Drives")
		GUICtrlSetData($drivecomboindex, StringUpper($fixeddrives[$i]), "All Drives")
	Next
EndIf
$menu = GUICtrlCreateMenu("&About")
$helpbutton = GUICtrlCreateMenuitem("&Help", $menu)
$aboutmenuitem = GUICtrlCreateMenuitem("&About", $menu)
HotKeySet("{F1}", "Help")
GUISetState()
#endregion
While 1
	$msg = GUIGetMsg()
	If $msg = $GUI_EVENT_CLOSE Then terminate()
	If $msg = $getindextime Then
		$listtodisplay = ""
		For $count = 1 To $fixeddrives[0]
			If FileExists(@ScriptDir & "\drive" & StringTrimRight($fixeddrives[$count], 1) & ".index") Then
				$listtodisplay &= "Index for drive " & StringUpper($fixeddrives[$count]) & " was last updated "
				$timestamp = FileGetTime(@ScriptDir & "\drive" & StringTrimRight($fixeddrives[$count], 1) & ".index", 0)
				$nonarraytimestamp = ""
				$nonarraytimestamp = $timestamp[1] & "/" & $timestamp[2] & "/" & $timestamp[0] & " at " & $timestamp[3] & ":" & $timestamp[4] & ":" & $timestamp[5] & @CRLF
				$listtodisplay &= $nonarraytimestamp
			Else
				$listtodisplay &= "No index for drive " & StringUpper($fixeddrives[$count]) & @CRLF
			EndIf
		Next
		$listtodisplay = StringTrimRight($listtodisplay, 1)
		MsgBox(64, "Index Files Last Updated:", "The following index files were last updated:" & @CRLF & @CRLF & $listtodisplay)
	EndIf
	If $msg = $startsearchbutton Then
		If GUICtrlRead($searchquierieinput) <> "" Then
			StartSearch()
		Else
			MsgBox(48, "Error", "You didn't enter a search query.")
		EndIf
	EndIf
	If $msg = $rebuildindexbutton Then
		GUISetState(@SW_HIDE, $mainGUI)
		$indexingGUI = GUICreate("Indexing... (Esc cancels)", 300, 50, (@DesktopWidth - 300) / 2, (@DesktopHeight - 50) / 2)
		$indexmainlabel = GUICtrlCreateLabel("Indexing.  This may take a while.  Please Wait...", 30, 1, 250, 25)
		$indexstatuslabel = GUICtrlCreateLabel("", 20, 25, 280, 20)
		GUISetState()
		$drivestoindex = GUICtrlRead($drivecomboindex)
		If $drivestoindex = "All Drives" Then
			$fixeddrives = DriveGetDrive("FIXED")
			If Not @error Then
				For $i = 1 To $fixeddrives[0]
					If CreateIndex($fixeddrives[$i]) = 0 Then ExitLoop
				Next
			EndIf
		Else
			CreateIndex($drivestoindex)
		EndIf
		GUIDelete($indexingGUI)
		GUISetState(@SW_SHOW, $mainGUI)
	EndIf
	If $msg = $helpbutton Then
		Help()
	EndIf
	If $msg = $aboutmenuitem Then
		AboutMsgbox()
	EndIf
WEnd
Func Help()
	If WinActive("Searching... (Esc cancels)") Or WinActive("Indexing... (Esc cancels)") Or WinActive("AutoIt Search Engine") Then
		Local $helplocation = @ScriptDir & "\help.htm"
;~ 		FileInstall("C:\programs\SearchEngine\help.htm", $helplocation, 1)
;~ 		FileInstall("C:\AUTO it Scripts\Search Engine\compiled released\help.htm", $helplocation, 1)
		Run(@ComSpec & " /c " & FileGetShortName($helplocation), "", @SW_HIDE)
	Else
		HotKeySet("{F1}")
		Send("{F1}")
		HotKeySet("{F1}", "Help")
	EndIf
EndFunc   ;==>Help
Func StartSearch()
	Opt("GUIOnEventMode", 1)
	$usercancel = False
	$filecounter = 0
	$closebuttonstatus = False
	HotKeySet("{Esc}", "Cancel")
	GUISetState(@SW_HIDE, $mainGUI)
	$readdrivecombo = GUICtrlRead($drivecombo)
	$searchquierie = GUICtrlRead($searchquierieinput)
	$searchGUI = GUICreate("Searching... (Esc cancels)", 810, 623, (@DesktopWidth - 800) / 2, (@DesktopHeight - 600) / 2, $WS_MAXIMIZEBOX + $WS_MINIMIZEBOX);BitOr($WS_SIZEBOX, $WS_MAXIMIZEBOX, $WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU))
	GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
	$timerstamp = TimerInit()
	$begin = TimerInit()
	$searchbegin = TimerInit()
	GUISetOnEvent($GUI_EVENT_CLOSE, "SpecialEvents")
	GUISetOnEvent($GUI_EVENT_MINIMIZE, "SpecialEvents")
	GUISetOnEvent($GUI_EVENT_RESTORE, "SpecialEvents")
	GUISetOnEvent($GUI_EVENT_PRIMARYDOWN, "PrimaryDown")
	$openbutton = GUICtrlCreateButton("Open", 10, 550, 50, 20)
	GUICtrlSetOnEvent(-1, "OpenPressed")
	$stopbutton = GUICtrlCreateButton("Stop", 70, 550, 50, 20)
	GUICtrlSetOnEvent(-1, "StopPressed")
	$searchlistView = GUICtrlCreateListView("Filename|Location|Size|Date Modified|Date Created|File Extension", 10, 10, 790, 530, $LVS_REPORT)
	GUICtrlSetOnEvent(-1, "ListViewClicked")
	$searchlisviewmenu = GUICtrlCreateContextMenu($searchlistView)
	$fileitemOpen = GUICtrlCreateMenuitem("Open", $searchlisviewmenu)
	GUICtrlSetOnEvent(-1, "OpenPressed")
	$statuslabel = GUICtrlCreateLabel("", 10, 580, 790, 20)
	$statuslabel2 = GUICtrlCreateLabel("", 130, 550, 790, 20)
	$timestatuslabel = GUICtrlCreateLabel("", 130, 565, 790, 15)
	GUISetState()
	GUISetState(@SW_MAXIMIZE)
	For $intcouter = 0 To UBound($B_DESCENDING) - 1
		_GUICtrlListViewSetColumnWidth($searchlistView, $intcouter, (@DesktopWidth - 20) / UBound($B_DESCENDING))
	Next
	Local $InFile = '...'
;~ 	Local $OutFile = @ScriptDir & "\results.txt"
	Local $resultsarray
	Local $Search = '...'
	Local $i = 0
	Local $j = 0
	Local $searchlistitemarray
	Local $filesize
	Dim $masterfilecounter
	$masterfilecounter = 0
	$openfilequeryhwnd = FileOpen("searchquery.txt", 2)
	FileWrite($openfilequeryhwnd, $searchquierie)
	FileClose($openfilequeryhwnd)
	If $readdrivecombo = "All Drives" Then
		For $drivecounter = 1 To $fixeddrives[0]
			If $closebuttonstatus = True Or $usercancel = True Then Exitloop
			If FileExists(@ScriptDir & "\drive" & StringUpper(StringLeft($fixeddrives[$drivecounter], 1)) & ".index") Then
				FileMove(@ScriptDir & "\drive" & StringUpper(StringLeft($fixeddrives[$drivecounter], 1)) & ".index", @ScriptDir & "\file_arranged.txt", 1)
				$filesearchpid = Run("filesearch.exe", @ScriptDir, @SW_HIDE)
				While ProcessExists($filesearchpid)
					$current = _GUICtrlListViewGetHotItem ($searchlistView)
					Sleep(10)
;~ 					If $closebuttonstatus = True Or $usercancel = True Then Exitloop
				WEnd
				_FileReadToArray("results.txt", $resultsarray)
				For $resultsarraycounter = 1 To $resultsarray[0] - 1
					Local $szDrive, $szDir, $szFName, $szExt
					_PathSplit($resultsarray[$resultsarraycounter], $szDrive, $szDir, $szFName, $szExt)
					$szExt2 = $szExt
					$filesize = FileGetSize($resultsarray[$resultsarraycounter]) / 1024
					Getfiletime($resultsarray[$resultsarraycounter])
					If $szExt = "" and $filesize = 0 Then
						$szExt = "Folder"
						$filesize = ""
						$szExt2 = ""
					Endif
					_GUICtrlListViewInsertItem($searchlistView, -1, $szFName & $szExt2 & "|" & $szDrive & $szDir & "|" & Round($filesize, 2) & " KB|" & $nonarraymodifiedtimestamp & "|" & $nonarraycreatedtimestamp & "|" & $szExt)
					$masterfilecounter += 1
					If MOD($masterfilecounter,100) = 0 Then
						GUICtrlSetData($statuslabel, "Found " & $masterfilecounter & " files.")
					Endif
					If $closebuttonstatus = True Or $usercancel = True Then Exitloop
				Next
				FileMove(@ScriptDir & "\file_arranged.txt", @ScriptDir & "\drive" & StringUpper(StringLeft($fixeddrives[$drivecounter], 1)) & ".index", 1)
			Else
				MsgBox(48,"Error!","The index for drive "& StringUpper($fixeddrives[$drivecounter]) &" is non-existent.  Please index this drive before searching it.")
			Endif
			
		Next
		If $closebuttonstatus = True Or $usercancel = True Then 
			IF Ubound($fixeddrives) >= $drivecounter +1 Then
				FileMove(@ScriptDir & "\file_arranged.txt", @ScriptDir & "\drive" & StringUpper(StringLeft($fixeddrives[$drivecounter], 1)) & ".index", 1)
			Endif
		Endif
	Else
		If FileExists(@ScriptDir & "\drive" & StringUpper(StringLeft($readdrivecombo, 1)) & ".index") Then
			FileMove(@ScriptDir & "\drive" & StringUpper(StringLeft($readdrivecombo, 1)) & ".index", @ScriptDir & "\file_arranged.txt", 1)
			$filesearchpid = Run("filesearch.exe", @ScriptDir, @SW_HIDE)
			While ProcessExists($filesearchpid)
				$current = _GUICtrlListViewGetHotItem ($searchlistView)
				Sleep(10)
;~ 				If $closebuttonstatus = True Or $usercancel = True Then Exitloop
			WEnd
			_FileReadToArray("results.txt", $resultsarray)
			For $resultsarraycounter = 1 To $resultsarray[0] - 1
				Local $szDrive, $szDir, $szFName, $szExt
				_PathSplit($resultsarray[$resultsarraycounter], $szDrive, $szDir, $szFName, $szExt)
				$szExt2 = $szExt
				$filesize = FileGetSize($resultsarray[$resultsarraycounter]) / 1024
				Getfiletime($resultsarray[$resultsarraycounter])
				If $szExt = "" and $filesize = 0 Then
					$szExt = "Folder"
					$filesize = ""
					$szExt2 = ""
				Endif
				_GUICtrlListViewInsertItem($searchlistView, -1, $szFName & $szExt2 & "|" & $szDrive & $szDir & "|" & Round($filesize, 2) & " KB|" & $nonarraymodifiedtimestamp & "|" & $nonarraycreatedtimestamp & "|" & $szExt)
				$masterfilecounter += 1
				If MOD($masterfilecounter,100) = 0 Then
					GUICtrlSetData($statuslabel, "Found " & $masterfilecounter & " files.")
				Endif
				If $closebuttonstatus = True Or $usercancel = True Then Exitloop
			Next
			FileMove(@ScriptDir & "\file_arranged.txt", @ScriptDir & "\drive" & StringUpper(StringLeft($readdrivecombo, 1)) & ".index", 1)
		Else
			MsgBox(48,"Error!","The index for drive "& StringUpper($readdrivecombo) &" is non-existent.  Please index this drive before searching it.")
		Endif
	EndIf
	ConsoleWrite("Time :"&TimerDiff($begin) / 1000& " seconds to compile the array.")
	Opt("GUIOnEventMode", 0)
	GUICtrlSetData($statuslabel2, "")
	GUICtrlSetData($statuslabel, "Done!  Found " & $masterfilecounter & " files.")
	WinSetTitle("Searching... (Esc cancels)", "", "Search Results")
	HotKeySet("{Esc}")
	$numberofcolumns = _GUICtrlListViewGetSubItemsCount($searchlistView)
	If $closebuttonstatus = True Then
		GUIDelete($searchGUI)
		GUISetState(@SW_SHOW, $mainGUI)
		Return 0
	Endif
	$finaltimedifference = TimerDiff($searchbegin)
	$minutes = Floor($finaltimedifference / 60000)
	$seconds = Round((($finaltimedifference / 60000) - Floor($finaltimedifference / 60000)) * 60, 2)
	GUICtrlSetData($timestatuslabel,"Took " & $minutes & " mins:" & $seconds & " secs to complete the search.")

	GUICtrlSetState($stopbutton, $GUI_HIDE)
	$timerstamp = TimerInit()
	While 1
		$msg = GUIGetMsg()
		Select
			Case $msg = $GUI_EVENT_CLOSE
				GUIDelete($searchGUI)
				GUISetState(@SW_SHOW, $mainGUI)
				ExitLoop
			Case $msg = $openbutton
				Local $a_indices = _GUICtrlListViewGetSelectedIndices($searchlistView, 1)
				If (IsArray($a_indices)) Then
					Local $i2
					For $i2 = 1 To $a_indices[0]
						$a_Item = _GUICtrlListViewGetItemTextArray($searchlistView, $a_indices[$i2])
						If (Not IsArray($a_Item)) Then
						Else
							_RunDOS("@Start " & FileGetShortName($a_Item[2] & $a_Item[1]))
						EndIf
					Next
				Else
				EndIf
			Case $msg = $fileitemOpen
				Local $a_indices = _GUICtrlListViewGetSelectedIndices($searchlistView, 1)
				If (IsArray($a_indices)) Then
					Local $i2
					For $i2 = 1 To $a_indices[0]
						$a_Item = _GUICtrlListViewGetItemTextArray($searchlistView, $a_indices[$i2])
						If (Not IsArray($a_Item)) Then
						Else
							_RunDOS("@Start " & FileGetShortName($a_Item[2] & $a_Item[1]))
						EndIf
					Next
				Else
				EndIf
		EndSelect
		Select
			Case $msg = $GUI_EVENT_PRIMARYDOWN
				$pos = GUIGetCursorInfo()
				If ($pos[4] == $searchlistView) Then
					If (TimerDiff($timerstamp) / 1000 > 2 And _GUICtrlListViewGetHotItem($searchlistView) >= 0) Then
						$current = _GUICtrlListViewGetHotItem($searchlistView)
						$timerstamp = TimerInit()
					ElseIf ($current = _GUICtrlListViewGetHotItem($searchlistView) And _GUICtrlListViewGetHotItem($searchlistView) >= 0) Then
						If TimerDiff($timerstamp) / 1000 <= 2 Then
							Run("explorer.exe /select, " & FileGetShortName(_GUICtrlListViewGetItemText($searchlistView, $current, 1) & _GUICtrlListViewGetItemText($searchlistView, $current, 0)), "", @SW_MAXIMIZE)
						EndIf
					ElseIf (_GUICtrlListViewGetHotItem($searchlistView == -1)) Then
					EndIf
				EndIf
			Case $msg = $searchlistView
				_GUICtrlListViewSort($searchlistView, $B_DESCENDING, GUICtrlGetState($searchlistView))
		EndSelect
	WEnd
		ConsoleWrite("Time :"&TimerDiff($begin) / 1000& " seconds to compile the array.")
EndFunc   ;==>StartSearch
Func CreateIndex($driveletter)
	$begin = TimerInit()
	$exespath = @ScriptDir
	GUICtrlSetData($indexstatuslabel, "Creating an index for drive " & StringUpper($driveletter) & "\. Please wait...")
	$exebathwnd = FileOpen("exe.bat", 2)
	FileWriteLine($exebathwnd, '"' & $exespath & '\fi.exe" /s /b ' & $driveletter & '\ > "' & $exespath & '\file.txt"')
	FileClose($exebathwnd)
	ConsoleWrite("Time :"&TimerDiff($begin) / 1000& " seconds to Do FileWriteLine($exebathwnd,"&@LF)
	$fipid = "fi.exe"
	Run(@ScriptDir & "\exe.bat", @ScriptDir, @SW_HIDE)
	ConsoleWrite("Time :"&TimerDiff($begin) / 1000& " seconds to Do start running & '\exe.bat'"&@LF)
	While 1
		If ProcessExists($fipid) Then ExitLoop
		Sleep(10)
	WEnd
	ConsoleWrite("Time :"&TimerDiff($begin) / 1000& " seconds to Do the @ScriptDir & '\exe.bat'"&@LF)
	While ProcessExists($fipid)
		$msg = GUIGetMsg()
		Select
			Case $msg = $GUI_EVENT_CLOSE
				If Cancel() = True Then
					ProcessClose($fipid)
					FileDelete($exespath & '\file.txt')
					Return 0
				EndIf
		EndSelect
	WEnd
	ConsoleWrite("Time :"&TimerDiff($begin) / 1000& " about to sleep b4 dbcrtr.exe"&@LF)
;~ 	sleep(5000)
	$dbcrtrpid = Run($exespath & '\dbcrtr.exe', @ScriptDir, @SW_HIDE)
	While 1
		If ProcessExists($dbcrtrpid) Then ExitLoop
		Sleep(10)
	WEnd
	ConsoleWrite("Exited the second process exists loop"&@LF)
	ConsoleWrite("Total so farTime :"&TimerDiff($begin) / 1000& " seconds "&@LF)
	While ProcessExists($dbcrtrpid)
		$msg = GUIGetMsg()
		Select
			Case $msg = $GUI_EVENT_CLOSE
				If Cancel() = True Then
					ProcessClose($dbcrtrpid)
					FileDelete($exespath & '\file.txt')
					FileDelete($exespath & "\file_arranged.txt")
					Return 0
				EndIf
		EndSelect
	WEnd
	FileDelete($exespath & '\file.txt')
	FileDelete(@ScriptDir & "\exe.bat")
	FileMove($exespath & "\file_arranged.txt", $exespath & "\drive" & StringUpper(StringLeft($driveletter, 1)) & ".index", 1)
	ConsoleWrite("Total2 Time :"&TimerDiff($begin) / 1000& " seconds to Do the Single drive Index"&@LF)
	Return 1
EndFunc   ;==>CreateIndex
Func AboutMsgbox()
	$aboutGUI = GUICreate("About AutoIt Search Engine", 327, 195, (@DesktopWidth - 327) / 2, (@DesktopHeight - 195) / 2) ;215, 148)
	GUICtrlCreateLabel("The Kandie Man - Concept, GUI, Search Engine, Updater", 24, 32, 277, 17)
	GUICtrlCreateLabel(" randallc - Index Engine and code optimization", 24, 64, 221, 17)
	GUICtrlCreateLabel("Special thanks to greenmachine and the AutoIt forum community.", 16, 120, 311, 17)
	GUICtrlCreateLabel("Current Version:", 16, 160, 79, 17)
	$Group1 = GUICtrlCreateGroup("AutoIt Search Engine was created by:", 16, 8, 297, 89)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$versionlabel = GUICtrlCreateLabel($version, 96, 160, 82, 17)
	$okbutton = GUICtrlCreateButton("&OK", 224, 160, 73, 25)
	GUICtrlSetState($okbutton, $GUI_DEFBUTTON)
	GUISetState(@SW_SHOW)
	While 1
		$msg = GUIGetMsg()
		Select
			Case $msg = $GUI_EVENT_CLOSE
				ExitLoop
			Case $msg = $okbutton
				ExitLoop
		EndSelect
	WEnd
	GUIDelete($aboutGUI)
EndFunc   ;==>AboutMsgbox
Func Cancel()
	If WinActive("Searching... (Esc cancels)") Then
		$answer = MsgBox(292, "Cancel?", "Are you sure you want to cancel the search?")
		If $answer = 6 Then
			$usercancel = "true"
			HotKeySet("{Esc}")
		EndIf
	ElseIf WinActive("Indexing... (Esc cancels)") Then
		$answer = MsgBox(292, "Cancel?", "Are you sure you want to cancel the index?  All index progress will be lost.")
		If $answer = 6 Then
			$usercancel = "true"
			WinSetTitle("Indexing... (Esc cancels)", "", "Cancelling Index...")
			GUICtrlSetData($indexmainlabel, "Cancelling Index.  Please wait...")
			GUICtrlSetData($indexstatuslabel, "Locating and removing temporary files...")
			HotKeySet("{Esc}")
			Return True
		EndIf
	Else
		HotKeySet("{Esc}")
		Send("{Esc}")
		HotKeySet("{Esc}", "Cancel")
	EndIf
EndFunc   ;==>Cancel
Func SpecialEvents()
	Select
		Case @GUI_CtrlId = $GUI_EVENT_CLOSE
			$closebuttonstatus = True
		Case @GUI_CtrlId = $GUI_EVENT_MINIMIZE
			WinSetState("Searching...", "", @SW_MINIMIZE)
		Case @GUI_CtrlId = $GUI_EVENT_RESTORE
			WinSetState("Searching...", "", @SW_RESTORE)
	EndSelect
EndFunc   ;==>SpecialEvents
Func PrimaryDown()
	$pos = GUIGetCursorInfo()
	If ($pos[4] == $searchlistView) Then
		If (TimerDiff($timerstamp) / 1000 > 2 And _GUICtrlListViewGetHotItem($searchlistView) >= 0) Then
			$current2 = _GUICtrlListViewGetHotItem($searchlistView)
			$timerstamp = TimerInit()
		ElseIf ($current2 = _GUICtrlListViewGetHotItem($searchlistView) And _GUICtrlListViewGetHotItem($searchlistView) >= 0) Then
			If TimerDiff($timerstamp) / 1000 <= 2 Then
				Run("explorer.exe /select, " & FileGetShortName(_GUICtrlListViewGetItemText($searchlistView, $current2, 1) & _GUICtrlListViewGetItemText($searchlistView, $current2, 0)), "", @SW_MAXIMIZE)
			EndIf
		ElseIf (_GUICtrlListViewGetHotItem($searchlistView == -1)) Then
		EndIf
	EndIf
EndFunc   ;==>PrimaryDown
Func OpenPressed()
	Local $a_indices = _GUICtrlListViewGetSelectedIndices($searchlistView, 1)
	If (IsArray($a_indices)) Then
		Local $i2
		For $i2 = 1 To $a_indices[0]
			$a_Item = _GUICtrlListViewGetItemTextArray($searchlistView, $a_indices[$i2])
			If (Not IsArray($a_Item)) Then
			Else
				If UBound($a_Item) >= 3 Then
					_RunDOS("@Start " & FileGetShortName($a_Item[2] & $a_Item[1]))
				EndIf
			EndIf
		Next
	Else
	EndIf
EndFunc   ;==>OpenPressed
Func StopPressed()
	$usercancel = true
EndFunc   ;==>StopPressed
Func terminate()
	ConsoleWrite(@CRLF & "Exiting...")
	GUIDelete($mainGUI)
	DirCreate(@TempDir & "\updatetmp")
	$intsuccess = InetGet("http://www.thekandieman.com/applications/updates/seversion.ini", @TempDir & "\updatetmp\seversion.ini", 1)
	ConsoleWrite(@CRLF & "Done downloading ini file.  intsuccess = " & $intsuccess)
	If $intsuccess = 0 Then
		ConsoleWrite(@CRLF & "Error, could not retrieve the file from the remote site.")
	Else
		ConsoleWrite(@CRLF & "Reading first ini file")
		$latestversion = IniRead(@TempDir & "\updatetmp\seversion.ini", "Version", "Latest Updater Version", "error")
		ConsoleWrite(@CRLF & "Done reading first ini and returned value = " & $latestversion)
		ConsoleWrite(@CRLF & "Reading second ini file")
		$currentversion = IniRead(@ScriptDir & "\version.ini", "Version", "Current Updater Version", "error")
		ConsoleWrite(@CRLF & "Done reading second ini and returned value = " & $currentversion)
		If $latestversion <> "error" Then
			If $latestversion <> $currentversion Then
				ConsoleWrite(@CRLF & "Starting download...")
				$intsuccess = InetGet("http://www.thekandieman.com/applications/updates/SEUpdate.dat", @TempDir & "\updatetmp\SEUpdate.exe", 1)
				If $intsuccess <> 0 Then
					FileMove(@TempDir & "\updatetmp\SEUpdate.exe", @ScriptDir & "\SEUpdate.exe", 1)
					ConsoleWrite(@CRLF & "Done, intsuccess = " & $intsuccess)
				Else
					ConsoleWrite(@CRLF & "Error, could not retrieve the remote file to update from off the server.")
				EndIf
			EndIf
		EndIf
	EndIf
	If FileExists(@TempDir & "\updatetmp\") Then
		DirRemove(@TempDir & "\updatetmp\", 1)
	EndIf
	Exit
EndFunc   ;==>terminate
Func ListViewClicked()
	_GUICtrlListViewSort($searchlistView, $B_DESCENDING, GUICtrlGetState($searchlistView))
EndFunc   ;==>ListViewClicked
Func Getfiletime($file)
	$modifiedtimestamp = FileGetTime($file, 0, 0)
	$createdtimestamp = FileGetTime($file, 1, 0)
;~ 	If StringInStr($Line, ".", 0, -1) Then
;~ 		$fileExtension = StringTrimLeft($Line, StringInStr($Line, ".", 0, -1))
;~ 	Else
;~ 		$fileExtension = ""
;~ 	EndIf
	If IsArray($modifiedtimestamp) Then
		$nonarraymodifiedtimestamp = $modifiedtimestamp[1] & "/" & $modifiedtimestamp[2] & "/" & $modifiedtimestamp[0] & " at " & $modifiedtimestamp[3] & ":" & $modifiedtimestamp[4] & ":" & $modifiedtimestamp[5]
	Else
		$nonarraymodifiedtimestamp = ""
	EndIf
	If IsArray($createdtimestamp) Then
		$nonarraycreatedtimestamp = $createdtimestamp [1] & "/" & $createdtimestamp[2] & "/" & $createdtimestamp[0] & " at " & $createdtimestamp[3] & ":" & $createdtimestamp[4] & ":" & $createdtimestamp[5]
	Else
		$nonarraycreatedtimestamp = ""
	EndIf
EndFunc   ;==>Getfiletime