;searchFastIndex.au3 0_19
;Search Engine/Index Engine
;Author: Brian Prike aka The Kandie Man
;tested and compiled with AutoIt v3.1.1.70 (BETA)
;an attempt to compile this with a non-beta version of AutoIt will result in failure, your failure, and then we will all point and laugh at you
;Special thanks to Alex Peters aka LxP of Melbourne, Australia for help when the project was in early development.  Also to SmOke_N for helping me.  Special thanks to Autoit support.   http://www.autoitscript.com/forum
;known issue:  This program will have to re-index the same drives if you have a dual windows boot and the drives don't have the same drive letter names
;this file has been commented on, mostly
;Must Edit line 128 before compile so that it has the correct location of the help file
;Special thanks to Randallc for the DOS Engine Design
;hides the tray(obviously)
#region startup
;#NoTrayIcon
Opt("RunErrorsFatal", 0)
;a small error handler, just gets rid of the ugly autoit error, i hope.  Comment it out when debugging
ObjEvent("AutoIt.Error", "Error")
;some files to include, not sure which ones i actually still need since i didn't delete them after i got rid of some functions that required them
#include-once
#include <GuiConstants.au3>
#include <misc.au3>
#include <file.au3>
#include <Array.au3>
#Include <GuiListView.au3>
#include <process.au3>
#include "_GUICtrlListView.au3"
;a whole bunch of declared global variables
;not even sure which ones i don't use, but haven't bothered since they don't use that much memory:P
Global $mainGUI
Global $s_ComputerName=@ComputerName
Global $indexstatuslabel, $indexmainlabel
Global $number,$s_AnswerFile = @ScriptDir & "AnswerFindLines.txt"
_FileCreate(@ScriptDir&"\AnswerFindLines.txt")
$s_AnswerFile=FileGetShortName($s_AnswerFile)
Global $number,$s_AnswerFile_DosIndex = @ScriptDir & "AnsFullPath.txt"
_FileCreate(@ScriptDir&"\AnsFullPath.txt")
$s_AnswerFile_DosIndex=FileGetShortName($s_AnswerFile_DosIndex)
Global $filetosave
Global $file
Global $filesize
Global $usercancel
Global $drive
Global $filearray
Global $filetosave = @ScriptDir & "\indexdata.index"
Global $searchquierie
Global $filetosavehandle
Global $filepath
Global $fixeddrives
Global $indexoutput
Global $indexinput
Global $fileoutput
Global $filecounter
Global $CurrentFile, $s_CurrentFile
Global $titleindex
Global $ExportFile
Global $closebuttonstatus
Global $searchlistView ;so that it can be used by GUISETONEVENT functions
Global $B_DESCENDING[6] ;used for the number of columns in the search list view
Global $timerstamp ; a timerstamp used by the list view to determine if the user double clicked by finding the difference in time between the two clicks
Global $current2 ;used to determine the current object selected in the listview
Global $searchlisviewmenu ;so that it can be used by the GUISETONEVENT functions
;update management
;write the current version of this .exe to the ini file so that the autoupdater knows what version it is
INIWrite(@ScriptDir & "\version.ini","Version","Current Version","1.5.1.9 build9")
;If FileExists(@ScriptDir & "\SEUpdate.exe") Then
;	Run(@ComSpec & " /c " & "@start " & FileGetShortName(@ScriptDir & "\SEUpdate.exe"), "", @SW_HIDE)
;EndIf
;used GUI builder created by CyberSlug
$mainGUI = GUICreate("AutoIt Fast Search; Fast index  Search Engine", 600, 300, (@DesktopWidth - 600) / 2, (@DesktopHeight - 300) / 2) ;$WS_OVERLAPPEDWINDOW + $WS_VISIBLE + $WS_CLIPSIBLINGS)
$lblasdf = GUICtrlCreateGroup("Search", 10, 60, 580, 110)
$Label_2 = GUICtrlCreateLabel("AutoIt Fast Search", 200, 35, 200, 30, $ES_CENTER)
$searchquierieinput = GUICtrlCreateInput("", 250, 90, 310, 20)
$Label_4 = GUICtrlCreateLabel("A filename or part of a filename to search for:", 20, 90, 210, 20)
$startsearchbutton = GUICtrlCreateButton("Search", 200, 130, 100, 30)
$Group_6 = GUICtrlCreateGroup("Indexing", 10, 180, 580, 100)
$rebuildindexbutton = GUICtrlCreateButton("Rebuild Index", 260, 220, 80, 30)
$helpbutton = GUICtrlCreateButton("Help", 500, 10, 75, 20)
$getindextime = GUICtrlCreateButton("Get Index Date", 390, 220, 80, 30)
$DrivesAll= GUICtrlCreateCheckbox("Drives All [Off Fixed]", 310, 130, 250, 15)
GUICtrlSetState ($DrivesAll,$GUI_CHECKED)
GUICtrlSetState($startsearchbutton, $GUI_DEFBUTTON)
GUICtrlSetFont($Label_2, 14)
GUICtrlCreateLabel("Search for files in:", 20, 133, 100, 30)
;===================~ $fastradio = GUICtrlCreateRadio("Fast Search(Uses all CPU. Can't control GUI)", 310, 120, 250, 25)
GUICtrlCreateLabel("Index the files in:", 60, 233, 100, 30)
Global $s_DriveTypes=_iif(GUICtrlRead($DrivesAll)>1,"FIXED","ALL")
$drivecombo = GUICtrlCreateCombo($s_DriveTypes&" Drives", 110, 130, 70, 30, $CBS_DROPDOWNLIST)
$drivecomboindex = GUICtrlCreateCombo($s_DriveTypes&" Drives", 150, 230, 70, 30, $CBS_DROPDOWNLIST)
$fixeddrives = DriveGetDrive( $s_DriveTypes)
;_ArrayDisplay($fixeddrives,"1")
For $count = ubound($fixeddrives)-1 to 1 step -1
	if DriveGetType( $fixeddrives[$count] )="REMOVABLE" or DriveGetType( $fixeddrives[$count] )="CDROM" or StringInStr($fixeddrives[$count],"a") Then
		_ArrayDelete($fixeddrives,$count)
		$count += 1
	EndIf
Next
;_ArrayDisplay($fixeddrives,"2")
If Not @error Then
	GUICtrlSetData($drivecombo, "", $s_DriveTypes&" Drives")
	GUICtrlSetData($drivecombo, $s_DriveTypes&" Drives", $s_DriveTypes&" Drives")
	For $i = 1 To ubound($fixeddrives)-1
		GUICtrlSetData($drivecombo, StringUpper($fixeddrives[$i]), $s_DriveTypes&" Drives")
		GUICtrlSetData($drivecomboindex, StringUpper($fixeddrives[$i]), $s_DriveTypes&" Drives")
	Next
EndIf
;===================~ $slowradio = GUICtrlCreateRadio("Slower Search(Can stop search midway/open files)", 310, 140, 270, 25)
;~ GUICtrlSetState($fastradio, $GUI_CHECKED)
GUISetState()
_ReduceMemory()
#endregion
While 1
	;while loop for the main GUI, the very simple main one that starts up first
	$msg = GUIGetMsg()
	If $msg = $GUI_EVENT_CLOSE Then terminate()
	$s_DriveTypes=_iif(GUICtrlRead($DrivesAll)>1,"FIXED","ALL")
	$fixeddrives = DriveGetDrive( $s_DriveTypes)
	For $count = ubound($fixeddrives)-1 to 1 step -1
		if DriveGetType( $fixeddrives[$count] )="REMOVABLE" or DriveGetType( $fixeddrives[$count] )="CDROM" or StringInStr($fixeddrives[$count],"a") Then
			_ArrayDelete($fixeddrives,$count)
			$count += 1
		EndIf
	Next
	$readdrivecomboindex = GUICtrlRead($drivecomboindex)
	Select
		Case $msg = $GUI_EVENT_CLOSE
			ExitLoop
		Case $msg = $getindextime
			$listtodisplay = ""
			For $count = 1 to ubound($fixeddrives)-1
				if FileExists(@scriptdir & "\"&$s_ComputerName&"FastIndex_DBtitle" & StringTrimRight(StringUpper($fixeddrives[$count]),1)& ".index") then
					$listtodisplay &= "Index for drive " & StringUpper($fixeddrives[$count]) & " was last updated "
					$timestamp = FileGetTime(@scriptdir & "\"&$s_ComputerName&"FastIndex_DBtitle" & StringTrimRight(StringUpper($fixeddrives[$count]),1) & ".index",0)
					$nonarraytimestamp = ""
					$nonarraytimestamp =  $timestamp[0] & "/" & $timestamp[1] & "/" & $timestamp[2] & " at " & $timestamp[3] & ":" & $timestamp[4] & ":"& $timestamp[5] & @CRLF
					$listtodisplay &= $nonarraytimestamp
				EndIf
			Next
			$listtodisplay = StringTrimRight($listtodisplay,1)
			If Not @error Then
				GUICtrlSetData($drivecomboindex, "", $s_DriveTypes&" Drives")
				GUICtrlSetData($drivecomboindex, $s_DriveTypes&" Drives", $s_DriveTypes&" Drives")
				GUICtrlSetData($drivecomboindex, $readdrivecomboindex, $readdrivecomboindex)
				For $i = 1 To ubound($fixeddrives)-1
					GUICtrlSetData($drivecombo, StringUpper($fixeddrives[$i]), $readdrivecomboindex)
					GUICtrlSetData($drivecomboindex, StringUpper($fixeddrives[$i]),$readdrivecomboindex)
				Next
				GUICtrlSetData($drivecombo, "ALL Drives", "ALL Drives")
			EndIf
			MsgBox(64,"Index Files Last Updated:","The following index files were last updated:" & @CRLF & @CRLF & $listtodisplay)
		Case $msg = $startsearchbutton
			If GUICtrlRead($searchquierieinput) <> "" Then
				Call(StartSearch())
			Else
				MsgBox(48, "Error", "You didn't enter a search query.")
			EndIf
		Case $msg = $rebuildindexbutton
			CMDIndex()
		Case $msg = $helpbutton
			;Local $helplocation = @ScriptDir & "\help.htm"
			;FileInstall("C:\AUTO it Scripts\Search Engine\compiled released\help.htm", $helplocation, 1)
			;Run(@ComSpec & " /c " & FileGetShortName($helplocation), "", @SW_HIDE)
	EndSelect
WEnd
Func StartSearch()
	$s_DriveTypes=_iif(GUICtrlRead($DrivesAll)>1,"FIXED","ALL")
	$fixeddrives = DriveGetDrive( $s_DriveTypes)
	$readdrivecomboindex = GUICtrlRead($drivecomboindex)
	$n1TimerQuery = TimerInit()
	Opt("GUIOnEventMode", 1)
	$usercancel = "false"
	$filecounter = 0
	$closebuttonstatus = "false"
	HotKeySet("{Esc}", "Cancel")
	If Not FileExists(@ScriptDir & "\results.txt") Then
		_FileCreate(@ScriptDir & "\results.txt")
	EndIf
	GUISetState(@SW_HIDE, $mainGUI)
	$readdrivecombo = GUICtrlRead($drivecombo)
	$searchquierie = GUICtrlRead($searchquierieinput)
	$searchGUI = GUICreate("Searching... (Esc cancels)", 810, 623, (@DesktopWidth - 800) / 2, (@DesktopHeight - 600) / 2,$WS_MAXIMIZEBOX  + $WS_MINIMIZEBOX)
	;set on event which allows the interface to respond to the user while it is searching
	$timerstamp = TimerInit()
	GUISetOnEvent($GUI_EVENT_CLOSE, "SpecialEvents")
	GUISetOnEvent($GUI_EVENT_MINIMIZE, "SpecialEvents")
	GUISetOnEvent($GUI_EVENT_RESTORE, "SpecialEvents")
	GUISetOnEvent($GUI_EVENT_PRIMARYDOWN, "PrimaryDown")
	$openbutton = GUICtrlCreateButton("Open", 10, 550, 50, 20)
	GUICtrlSetOnEvent(-1, "OpenPressed")
	$stopbutton = GUICtrlCreateButton("Stop", 70, 550, 50, 20)
	GUICtrlSetOnEvent(-1, "StopPressed")
	$searchlistView = _GUICtrlCreateListView("Filename|Location|Size [Kb]|Date Modified|Date Created|Extension", 10, 10, 790, 530, $LVS_REPORT)
	GUICtrlSetOnEvent(-1, "ListViewClicked")
	$searchlisviewmenu = GUICtrlCreateContextMenu($searchlistView)
	$fileitemOpen = GUICtrlCreateMenuItem("Open", $searchlisviewmenu)
	GUICtrlSetOnEvent(-1, "OpenPressed")
	$statuslabel = GUICtrlCreateLabel("", 10, 580, 790, 20)
	$statuslabel2 = GUICtrlCreateLabel("", 130, 550, 790, 20)
	$timestatuslabel = GUICtrlCreateLabel("", 130, 565, 790, 15)
	GUISetState()
	GUISetState(@SW_MAXIMIZE)
	For $intcouter = 0 to Ubound($B_DESCENDING)-1
		_GUICtrlListViewSetColumnWidth($searchlistView, $intcouter, (@DesktopWidth-20)/Ubound($B_DESCENDING))
	Next
	$statuslabel = GUICtrlCreateLabel("", 10, 580, 790, 20)
	Local $InFile = '...'
	Local $OutFile = @ScriptDir & "\results.txt"
	Local $Search = '...'
	Local $i = 0, $ar_Dirs[1],$s_Dirs
	Local $j = 0,$fileNameLast,$s_SuccessDelete
	Local $searchlistitemarray
	Dim $masterfilecounter
	$masterfilecounter = 0
	$s_AnswerFile=@ScriptDir&"\AnswerFindLines.txt"
	if not FileDelete($s_AnswerFile) then $s_AnswerFile=@ScriptDir&"\AnswerFindLines"&@hour&@MIN&@SEC&".txt"
	;===========================================================================================================
	If $readdrivecombo = "ALL Drives" Then
		$searchbegin = TimerInit()
		$1secondtimestamp = TimerInit()
		$current = _GUICtrlListViewGetHotItem ($searchlistView)
		For $i = 1 To ubound($fixeddrives)-1
			$filepath = @ScriptDir & "\"&$s_ComputerName&"FastIndex_DBtitle" & StringTrimRight($fixeddrives[$i], 1) & ".index"
			$sFile = @ScriptDir & "\"&$s_ComputerName&"FastIndex_"& StringUpper(StringTrimRight($fixeddrives[$i], 1))&"_.txt"
			$masterfilecounter+=_FileCountLines($sFile)
			$masterindexpath = @ScriptDir & "\"&$s_ComputerName&"FastIndex_DBmasterindex" & StringTrimRight($fixeddrives[$i], 1) & ".index"
			Local $InHandle = FileOpen($masterindexpath, 0)
			local $s_Drop="",$sOutput
			If not ($InHandle = -1) and  FileExists(  $sFile) Then
				;===========================================================================================================
				$s_DefSwitches='/I  /c:"'&$searchquierie&'"'       ; Change only if you know FINDSTR switches well
				$Append=_Iif($i=1,0,1)
				_FindLinesDOSsearch2($sFile,$s_AnswerFile,$s_DefSwitches,$Append); AnswerFile ByRef
				;===========================================================================================================
			EndIf
			Local $OutHandle = FileOpen($OutFile, 1)
			FileWriteLine($OutHandle, "Search for results for '" & $searchquierie & "' on drive " & $fixeddrives[$i] & ".")
			FileClose($InHandle)
			FileClose($OutHandle)
		Next
		FileClose($s_AnswerFile)
	Else
		$searchbegin = TimerInit()
		$1secondtimestamp = TimerInit()
		$current = _GUICtrlListViewGetHotItem ($searchlistView)
		$filepath = @ScriptDir & "\"&$s_ComputerName&"FastIndex_DBtitle" & StringTrimRight($readdrivecombo, 1) & ".index"
		$sFile = @ScriptDir & "\"&$s_ComputerName&"FastIndex_"& StringUpper(StringTrimRight($readdrivecombo, 1))&"_.txt"
		$masterindexpath = @ScriptDir & "\"&$s_ComputerName&"FastIndex_DBmasterindex" & StringTrimRight($readdrivecombo, 1) & ".index"
		Local $InHandle = FileOpen($masterindexpath, 0)
		$masterfilecounter+=_FileCountLines($sFile)
		If $InHandle = -1 Then
			MsgBox(48, "No Index File Found", "No index file found for drive " & $readdrivecombo & ". Please rebuild the index.  " & @CRLF & @CRLF & "If this is your first time using this search engine, you must build an index.  Please select the drive you wish to build the index for on the main screen in the indexing group box. Then click the 'Rebuild Index' button." & @CRLF & @CRLF & "Once the index has been built the search engine should work faster than the explorer search companion.  It can take as little as 10 min to build an index, though it will most likely take longer.  The time it takes to build an index is determined by how many drives you have and how many files you have.")
			$usercancel = "true"
		EndIf
		Local $OutHandle = FileOpen($OutFile, 1)
		FileWriteLine($OutHandle, "Search for results for '" & $searchquierie & "' on drive " & $readdrivecombo & ".")
		;===========================================================================================================
		$s_DefSwitches='/I  /c:"'&$searchquierie&'"'       ; Change only if you know FINDSTR switches well
		_FindLinesDOSsearch2($sFile,$s_AnswerFile,$s_DefSwitches,0); AnswerFile ByRef
		;===========================================================================================================
		FileClose($InHandle)
		FileClose($OutHandle)
	EndIf
	;===========================================================================================================
	;_LockAndWait2()
	$i_DimArray=_FileCountLines($s_AnswerFile)+1
	local $ar_GUISearchar[$i_DimArray]
	_ParseSearch ( $ar_GUISearchar,$s_AnswerFile, $searchquierie)
	;===========================================================================================================
	GUICtrlSetData($statuslabel2, "Found " & UBound($ar_GUISearchar)-1 & " files so far and have searched through " & $masterfilecounter & " files total.")
	for $r= 0 to UBound($ar_GUISearchar)-1
			_GUICtrlCreateListViewItem($ar_GUISearchar[$r], $searchlistView)
	Next
	;_ResetLockWait2()
	Opt("GUIOnEventMode", 0)
	If $closebuttonstatus = "true" Then
		GUIDelete($searchGUI)
		GUISetState(@SW_SHOW, $mainGUI)
		Return 0
	EndIf
	$finaltimedifference = TimerDiff($searchbegin)
	$minutes = Floor($finaltimedifference / 60000)
	$seconds = Round((($finaltimedifference / 60000) - Floor($finaltimedifference / 60000)) * 60, 0)
	GUICtrlSetData($timestatuslabel,"Took " & $minutes & " mins:" & $seconds & " secs to complete the search.")
	GUICtrlSetData($statuslabel2, "")
	GUICtrlSetData($statuslabel2, "Done!  Found " & UBound($ar_GUISearchar)-1  & " files after searching through " & $masterfilecounter & " files total.")
	WinSetTitle("Searching... (Esc cancels)", "", "Search Results")
	HotKeySet("{Esc}")
	$numberofcolumns = _GUICtrlListViewGetSubItemsCount ($searchlistView)
	_ReduceMemory()
	$timerstamp = TimerInit()
	While 1
		$msg = GUIGetMsg()
		Select
			Case $msg = $GUI_EVENT_CLOSE
				GUIDelete($searchGUI)
				GUISetState(@SW_SHOW, $mainGUI)
				ExitLoop
			Case ($msg = $openbutton) or ($msg = $fileitemOpen)
				Local $a_indices = _GUICtrlListViewGetSelectedIndices ($searchlistView, 1)
				If (IsArray($a_indices)) Then
					Local $i2
					For $i2 = 1 To $a_indices[0]
						$a_Item = _GUICtrlListViewGetItemTextArray ($searchlistView, $a_indices[$i2])
						If IsArray($a_Item) Then _RunDOS("@Start " & FileGetShortName($a_Item[2]));$a_Item[2] &
					Next
				EndIf
		EndSelect
		Select
			Case $msg = $GUI_EVENT_PRIMARYDOWN
				$pos = GUIGetCursorInfo()
				If ($pos[4] == $searchlistView) Then
					If (TimerDiff($timerstamp) / 1000 > 2 And _GUICtrlListViewGetHotItem ($searchlistView) >= 0) Then
						$current = _GUICtrlListViewGetHotItem ($searchlistView)
						$timerstamp = TimerInit()
					ElseIf ($current = _GUICtrlListViewGetHotItem ($searchlistView) And _GUICtrlListViewGetHotItem ($searchlistView) >= 0) Then
						If TimerDiff($timerstamp) / 1000 <= 2 Then
							Run("explorer.exe /select, " & FileGetShortName(_GUICtrlListViewGetItemText ($searchlistView, $current, 1) ), "", @SW_MAXIMIZE)
						EndIf
					EndIf
				EndIf
			Case $msg = $searchlistView
				__GUICtrlListViewSort ($searchlistView,$B_DESCENDING,  GUICtrlGetState($searchlistView))
		EndSelect
	WEnd
EndFunc   ;==>StartSearch
Func _ParseSearch (byref $ar_GUISearch,$s_AnswerFileF, $searchquierieF)
	local $i_InternationalDate=0,$i_AMPM=0
	$s_AMPM=_DateTimeFormat( _NowCalc(),3)
	if StringInStr($s_AMPM,"a") or StringInStr($s_AMPM,"p") then $i_AMPM=1
	$s_Xmas_Date=_DateTimeFormat ( "2006/12/25", 2)
	if StringLeft($s_Xmas_Date,2)="25" then $i_InternationalDate=1
	$code= 			'Function ParseSearch (byref arGUISearch,sAnswerFileF, searchquierieF)'
	$code &= @LF & 	'	dim j,Line,fileExtension, sDirsF'
	$code &= @LF & 	'	Dim objFileSystem: Set objFileSystem = CreateObject( "Scripting.FileSystemObject") '
	$code &= @LF & 	'	Dim InHandle:Set InHandle = objFileSystem.OpenTextFile(sAnswerFileF, 1)'
	$code &= @LF & 	'	Do While Not InHandle.AtEndOfStream'
	$code &= @LF & 	'		Line = InHandle.ReadLine'
	$code &= @LF & 	'		fileExtension = ""'
	$code &= @LF & 	'		If InStrRev(Line, ".") >InStrRev(Line, "\") Then fileExtension = mid(Line, InStrRev(Line, ".")+1)'
	$code &= @LF & 	'		fileName = mid(Line, InStrRev(Line, "\")+1)'
	$code &= @LF & 	'		do while 1'
	$code &= @LF & 	'			if not InStr(fileName, searchquierieF)>0 then'
	$code &= @LF & 	'				fileName=left(Line, InStrRev(Line, "\"))'
	$code &= @LF & 	'				Line=fileName'
	$code &= @LF & 	'				if  not InStr(sDirsF,fileName)>0 then'
	$code &= @LF & 	'					sDirsF=sDirsF&fileName'
	$code &= @LF & 	'				Else'
	$code &= @LF & 	'					exit do'
	$code &= @LF & 	'				End If'
	$code &= @LF & 	'				filesize =0'
	$code &= @LF & 	'				If not objFileSystem.FolderExists(left(Line,len(Line)-1)) Then exit do'
	$code &= @LF & 	'				Set demofile = objFileSystem.GetFolder(left(Line,len(Line)-1))'
	$code &= @LF & 	'				modifiedtimestamp = demofile.DateLastModified'
	$code &= @LF & 	'				createdtimestamp = demofile.DateCreated'
	$code &= @LF & 	'			Else'
	$code &= @LF & 	'				If not objFileSystem.FileExists(Line) Then exit do'
	$code &= @LF & 	'				Set demofile = objFileSystem.GetFile(Line)'
	$code &= @LF & 	'				filesize = demofile.size/ 1024'
	$code &= @LF & 	'				modifiedtimestamp = demofile.DateLastModified'
	$code &= @LF & 	'				createdtimestamp = demofile.DateCreated'
	$code &= @LF & 	'				Line=Replace(Line,fileName,"")'
	$code &= @LF & 	'			End If'
	$code &= @LF & 	'				if instr(left (modifiedtimestamp,2),"/")>0 then modifiedtimestamp="0"&modifiedtimestamp'
	$code &= @LF & 	'				if instr(left (createdtimestamp,2),"/")>0 then createdtimestamp="0"&createdtimestamp'
	$code &= @LF & 	'			modifiedtime=mid(modifiedtimestamp,12)'
	$code &= @LF & 	'			if instr(left (modifiedtime,2),":") then modifiedtime="0"&modifiedtime'
	$code &= @LF & 	'			createdtime=mid(createdtimestamp,12)'
	$code &= @LF & 	'			if instr(left (createdtime,2),":") then createdtime="0"&createdtime'
	$s_Time='&mid(modifiedtime,10,2)&" "&left(modifiedtime,8)'
	if  $i_AMPM then $s_Time=StringReplace($s_Time,"AM 12","AM 00")
	if not $i_InternationalDate then 	$code &= @LF & 'nonarraymodifiedtimestamp=mid(modifiedtimestamp,7,4)&"/"&Left(modifiedtimestamp,3)&mid(modifiedtimestamp,4,2)&" "'&$s_Time
	if  $i_InternationalDate then 		$code &= @LF & 'nonarraymodifiedtimestamp=mid(modifiedtimestamp,7,4)&mid(modifiedtimestamp,3,4)&Left(modifiedtimestamp,2)&" "'&$s_Time
	$s_Time='&mid(createdtime,10,2)&" "&left(createdtime,8)'
	if  $i_AMPM then $s_Time=StringReplace($s_Time,"AM 12","AM 00")
	if not $i_InternationalDate then 	$code &= @LF & 'nonarraycreatedtimestamp=mid(createdtimestamp,7,4)&"/"&Left(createdtimestamp,3)&mid(createdtimestamp,4,2)&" "'&$s_Time
	if  $i_InternationalDate then 		$code &= @LF & 'nonarraycreatedtimestamp=mid(createdtimestamp,7,4)&mid(createdtimestamp,3,4)&Left(createdtimestamp,2)&" "'&$s_Time
	$code &= @LF & 	'			arGUISearch(j)=fileName & "|" &Line & "|" &  Round(filesize, 2) &"|" &  nonarraymodifiedtimestamp & "|" & nonarraycreatedtimestamp & "|" & fileExtension'
	$code &= @LF & 	'			j = j + 1'
	$code &= @LF & 	'			exit do'
	$code &= @LF & 	'		Loop'
	$code &= @LF & 	'	Loop'
	$code &= @LF & 	'	InHandle.Close'
	$code &= @LF & 	'	redim preserve arGUISearch(j-1)'
	$code &= @LF & 	'	ParseSearch=arGUISearch'
	$code &= @LF & 	'End Function'
	$vbs = ObjCreate("ScriptControl")
	$vbs.language="vbscript"
	$vbs.addcode($code)
	$ar_GUISearch=$vbs.run("ParseSearch" , $ar_GUISearch,$s_AnswerFileF, $searchquierieF)
	$vbs=""
EndFunc   ;==>_SingleDriveIndex 
Func _SingleDriveIndex ()
	Local $s_Prepare;,$s_AnswerFile=@ScriptDir&"\AnsFullPath.txt"
	Local $s_CurrentFile
	;============================================================================Step 1 of 6
	GUICtrlSetData($indexstatuslabel, "Reading Files on Drive " & StringUpper($drive) & " Step 1 of 6")
	$begin = TimerInit()
	$s_Checker=FileFindFirstFile($drive&"\*")
	If $s_Checker = -1 or not FileExists($drive&"\") Then  return
	If $usercancel = "true" Then Return
	;writes the output to the file
	$sTimeStamp=TimerInit()
	;============================================================================Step 3 of 6
	GUICtrlSetData($indexstatuslabel, "Writing Index for Drive " & StringUpper($drive) & " to Memory - Step 3 of 6")
	$begin = TimerInit()
	GUICtrlSetData($indexstatuslabel, "Writing Index to File for Drive " & StringUpper($drive) & " Step 6 of 6")
	$filepath = @ScriptDir & "\"&$s_ComputerName&"FastIndex_DBtitle" & StringTrimRight($drive, 1) & ".index"
	$s_MasterIndex=@ScriptDir & "\"&$s_ComputerName&"FastIndex_DBmasterindex" & StringTrimRight($drive, 1) & ".index"
	_FileCreate($s_MasterIndex)
	_FileCreate($filepath)
	$sFile = @ScriptDir & "\"&$s_ComputerName&"FastIndex_"& StringUpper(StringTrimRight($drive, 1))&"_.txt"
	$n1TimerQuery = TimerInit()
	;===========================================================================================================
	_DosIndex($sFile)
	;===========================================================================================================
	ConsoleWrite("Time :"&TimerDiff($begin) / 1000& " seconds to compile the array.")
EndFunc   ;==>_SingleDriveIndex 
Func _DosIndex($s_AnswerDos)
	$sCommand=	" dir " & $drive & "\* /s/b /On /-C/a-d-h-s>" &  $s_AnswerDos
	ConsoleWrite($sCommand&@CRLF)
	RunWait (@ComSpec & " /c " & $sCommand, @WorkingDir, @SW_HIDE)
	$n1TimerQuery = TimerInit()
EndFunc   ;==>_DosIndex
Func CMDIndex()
	$nTimerQuery = TimerInit()
	If @Compiled = 1 Then
		ProcessSetPriority(@ScriptName, 0)
	EndIf
	HotKeySet("{Esc}", "Cancel")
	$indexoutput = ""
	$usercancel = "false"
	$begin3 = TimerInit()
	GUISetState(@SW_HIDE, $mainGUI)
	$indexingGUI = GUICreate("Indexing... (Esc cancels)", 300, 50, (@DesktopWidth - 300) / 2, (@DesktopHeight - 50) / 2)
	$indexingLabel=GUICtrlCreateLabel("Indexing.  This may take a while.  Please Wait...", 30, 1, 250, 25)
	$indexstatuslabel = GUICtrlCreateLabel("", 20, 25, 280, 20)
	GUISetState()
	$filecounter = 0
	$s_DriveTypes=_iif(GUICtrlRead($DrivesAll)>1,"FIXED","ALL")
	$fixeddrives = DriveGetDrive( $s_DriveTypes)
	$readdrivecomboindex = GUICtrlRead($drivecomboindex)
	if $readdrivecomboindex=="ALL Drives" then $readdrivecomboindex=$s_DriveTypes&" Drives"
	If Not @error Then
		GUICtrlSetData($drivecomboindex, "", $s_DriveTypes&" Drives")
		GUICtrlSetData($drivecomboindex, $s_DriveTypes&" Drives", $s_DriveTypes&" Drives")
		GUICtrlSetData($drivecomboindex, $readdrivecomboindex, $readdrivecomboindex)
		For $i = 1 To ubound($fixeddrives)-1
			GUICtrlSetData($drivecombo, StringUpper($fixeddrives[$i]), $readdrivecomboindex)
			GUICtrlSetData($drivecomboindex, StringUpper($fixeddrives[$i]),$readdrivecomboindex)
		Next
		GUICtrlSetData($drivecombo, "ALL Drives", "ALL Drives")
	EndIf
	If $readdrivecomboindex = $s_DriveTypes&" Drives" Then
		If Not @error Then
			;_ArrayDisplay($fixeddrives,"loop")
			;will loop the engine for every fixed|all drive on the computer
			For $drivenumber = 1 To ubound($fixeddrives)-1
				If $usercancel = "true" Then ExitLoop
				$drive = $fixeddrives[$drivenumber]
				_SingleDriveIndex ()
				If $usercancel = "true" Then ExitLoop
			Next
		EndIf
	Else
		$drive = $readdrivecomboindex
		_SingleDriveIndex ()
	EndIf
	If @Compiled = 1 Then
		ProcessSetPriority(@ScriptName, 2)
	EndIf
	GUISetState(@SW_HIDE, $indexingGUI)
	GUISetState(@SW_SHOW, $mainGUI)
	HotKeySet("{Esc}")
	If $usercancel = "true" Then
		MsgBox(0, "Cancelled", "The indexing has been cancelled.")
	Else
		$finaltimedifference = TimerDiff($begin3)
		$minutes = Floor($finaltimedifference / 60000)
		$seconds = Round((($finaltimedifference / 60000) - Floor($finaltimedifference / 60000)) * 60, 0)
		MsgBox(0, "Done", "Done Creating the Index.  It took " & $minutes & " minutes and " & $seconds & " seconds.")
	EndIf
	ConsoleWrite('@@ Debug(681) : ' & "NewEng" & "=" & Round(TimerDiff($nTimerQuery), 2) & " MSEC." & @LF) ;### Debug Console
EndFunc   ;==>CMDIndex
Func Cancel()
	;used in the event that a user presses Escape while the search engine is running or while the indexing engine is running.
	;checks to make sure the user is pressing cancel for the search engine and not for some other program that have open while the search engine is running
	If WinActive("Searching... (Esc cancels)") Then
		$answer = MsgBox(292, "Cancel?", "Are you sure you want to cancel the search?")
		If $answer = 6 Then
			$usercancel = "true"
			HotKeySet("{Esc}")
		EndIf
		;checks to make sure the user is pressing cancel for the indexing engine and not for some other program that have open while the indexing engine is running
	ElseIf WinActive("Indexing... (Esc cancels)") Then
		$answer = MsgBox(292, "Cancel?", "Are you sure you want to cancel the index?  All index progress will be lost.")
		If $answer = 6 Then
			$usercancel = "true"
			WinSetTitle("Indexing... (Esc cancels)", "", "Cancelling Index...")
			GUICtrlSetData($indexmainlabel, "Cancelling Index.  Please wait...")
			GUICtrlSetData($indexstatuslabel, "Locating and removing temporary files...")
			HotKeySet("{Esc}")
		EndIf
	Else
		HotKeySet("{Esc}")
		Send("{Esc}")
		HotKeySet("{Esc}", "Cancel")
	EndIf
EndFunc   ;==>Cancel
Func Error()
	;i wrote this in case the program encounters an error.  I was hoping this error message would be friendly than the "AUTO IT ERROR LINE 165 "fileClose()" blah blah"
	MsgBox(4112, "Error!", "An error has occured and the Search/Indexing Engine must close.")
	Exit
EndFunc   ;==>Error
Func SpecialEvents()
	Select
		Case @GUI_CtrlId = $GUI_EVENT_CLOSE
			$closebuttonstatus = "true"
		Case @GUI_CtrlId = $GUI_EVENT_MINIMIZE
			WinSetState("Searching...", "", @SW_MINIMIZE)
		Case @GUI_CtrlId = $GUI_EVENT_RESTORE
			WinSetState("Searching...", "", @SW_RESTORE)
	EndSelect
EndFunc   ;==>SpecialEvents
Func ListViewClicked()
	;_GUICtrlListViewSort ($searchlistView, $B_DESCENDING, GUICtrlGetState($searchlistView))
	__GUICtrlListViewSort ($searchlistView,$B_DESCENDING,  GUICtrlGetState($searchlistView))
EndFunc   ;==>ListViewClicked
Func PrimaryDown()
	$pos = GUIGetCursorInfo()
	If ($pos[4] == $searchlistView) Then
		If (TimerDiff($timerstamp) / 1000 > 2 And _GUICtrlListViewGetHotItem ($searchlistView) >= 0) Then
			;msgbox("", "Hot Item:" , _GUICtrlListViewGetHotItem ($searchlistView))
			$current2 = _GUICtrlListViewGetHotItem ($searchlistView)
			;msgbox(0,"",_GUICtrlListViewGetItemText($searchlistView, $current, 1))
			$timerstamp = TimerInit()
		ElseIf ($current2 = _GUICtrlListViewGetHotItem ($searchlistView) And _GUICtrlListViewGetHotItem ($searchlistView) >= 0) Then
			If TimerDiff($timerstamp) / 1000 <= 2 Then
				Run("explorer.exe /select, " & FileGetShortName(_GUICtrlListViewGetItemText ($searchlistView, $current2, 1) & _GUICtrlListViewGetItemText ($searchlistView, $current2, 0)), "", @SW_MAXIMIZE)
			EndIf
		ElseIf (_GUICtrlListViewGetHotItem ($searchlistView == -1)) Then
			;msgbox("", "Hot Item:" , "None")
		EndIf
	EndIf
EndFunc   ;==>PrimaryDown
Func OpenPressed()
	Local $a_indices = _GUICtrlListViewGetSelectedIndices ($searchlistView, 1)
	If (IsArray($a_indices)) Then
		Local $i2
		For $i2 = 1 To $a_indices[0]
			;MsgBox(0,"Selected", $a_indices[$i2])
;~ 			_ArrayDisplay($a_indices, "K")
			$a_Item = _GUICtrlListViewGetItemTextArray ($searchlistView, $a_indices[$i2])
			If (Not IsArray($a_Item)) Then
				;GUICtrlSetData($Status, "Nothing Selected")
			Else
				;For $i = 1 To $a_Item[0]
				;	MsgBox(0, "Passed Item Index only", "SubItem[" & $i & "] = " & $a_Item[$i])
				;Next
;~ 				_ArrayDisplay($a_Item, "K")
				If UBound($a_Item) >= 3 Then
					_RunDOS("@Start " & FileGetShortName($a_Item[2] & $a_Item[1]))
				EndIf
			EndIf
		Next
	Else
		;GUICtrlSetData($Status, "Not Items Selected")
	EndIf
EndFunc   ;==>OpenPressed
Func StopPressed()
	$usercancel = "true"
EndFunc   ;==>StopPressed
Func terminate()
	ConsoleWrite(@CRLF &"Exiting...")
	GUIDelete($mainGUI)
	DirCreate(@TempDir & "\updatetmp")
	$intsuccess = InetGet("http://www.thekandieman.com/applications/updates/seversion.ini", @TempDir & "\updatetmp\seversion.ini", 1)
	ConsoleWrite(@CRLF &"Done downloading ini file.  intsuccess = "& $intsuccess)
	If $intsuccess = 0 Then
		ConsoleWrite(@CRLF & "Error, could not retrieve the file from the remote site.")
	Else
		ConsoleWrite(@CRLF &"Reading first ini file")
		$latestversion = IniRead(@TempDir & "\updatetmp\seversion.ini", "Version", "Latest Updater Version", "error")
		ConsoleWrite(@CRLF &"Done reading first ini and returned value = "& $latestversion)
		ConsoleWrite(@CRLF &"Reading second ini file")
		$currentversion = IniRead(@ScriptDir & "\version.ini", "Version", "Current Updater Version", "error")
		ConsoleWrite(@CRLF &"Done reading second ini and returned value = "& $currentversion)
		If $latestversion <> "error" Then
			If $latestversion <> $currentversion Then
				ConsoleWrite(@CRLF &"Starting download...")
				$intsuccess = InetGet("http://www.thekandieman.com/applications/updates/SEUpdate.dat",@TempDir & "\updatetmp\SEUpdate.exe",1)
				If $intsuccess <> 0 Then
					FileMove(@TempDir & "\updatetmp\SEUpdate.exe",@ScriptDir & "\SEUpdate.exe",1)
					ConsoleWrite(@CRLF & "Done, intsuccess = " & $intsuccess)
				Else
					ConsoleWrite(@CRLF & "Error, could not retrieve the remote file to update from off the server.")
				Endif
			Endif
		Endif
	Endif
	If FileExists(@TempDir & "\updatetmp\") Then
		DirRemove(@TempDir & "\updatetmp\", 1)
	EndIf
	Exit
EndFunc   ;==>terminate
Func _ReduceMemory()
	Local $ai_GetCurrentProcessId = DllCall('kernel32.dll', 'int', 'GetCurrentProcessId')
	Local $ai_Handle = DllCall("kernel32.dll", 'int', 'OpenProcess', 'int', 0x1f0fff, 'int', False, 'int', $ai_GetCurrentProcessId[0])
	Local $ai_Return = DllCall("psapi.dll", 'int', 'EmptyWorkingSet', 'long', $ai_Handle[0])
	DllCall('kernel32.dll', 'int', 'CloseHandle', 'int', $ai_Handle[0])
	Return $ai_Return[0]
EndFunc   ;==>_ReduceMemory
Func _FindLinesDOSsearch2(ByRef $s_file, ByRef $s_AnswerFile, $s_Searches, $i_Append = 0, $i_Case = 0, $i_Array = 0, $i_Literal = 0)
	;Syntax; _FindLinesDOSsearch2($s_file,$s_AnswerFile,$s_Searches, $i_Case , $i_Array ,$i_Literal); $s_AnswerFile ByRef needs not be defined
	; Parameters; $i_Literal=1 implies spaces are delimiters for a number of search strings in $s_Searches, rather than spaces included in search
	Local $asList
	If FileExists($s_file) Then
		If $i_Append Then
			$i_Append = ">>"
		Else
			$i_Append = ">"
		EndIf
		If $i_Literal = 1 Then
			$i_Literal = "/c:"
		Else
			$i_Literal = ""
		EndIf
		If $i_Case = 1 Then
			$i_Case = "/I"
		Else
			$i_Case = ""
		EndIf
		$Position = StringInStr($s_file, "\", 0, -1)
		$s_Path = StringLeft($s_file, $Position)
		FileChangeDir($s_Path)
		;$s_AnswerFile = $s_Path & "AnswerFindLines.txt"
		$s_Searches = StringReplace($s_Searches, ".", "\."); to use as RegExp in "FindLines"
		$s_Searches = StringReplace($s_Searches, "*", ".*"); to use as RegExp in "FindLines"
		;$s_Searches = '"' & $s_Searches & '"'
		If StringInStr($s_file, " ") Then $s_file = '"' & $s_file & '"'
		If StringInStr($s_AnswerFile, " ") Then $s_AnswerFile = '"' & $s_AnswerFile & '"'
		; Set the Command and Run Dos
		;MsgBox(0,"","$s_AnswerFile="&$s_AnswerFile)
		$s_Command = 'type | findstr /R' & $i_Case & ' ' & $i_Literal & $s_Searches & ' ' & $s_file &' ' & $i_Append & '  ' & $s_AnswerFile; rem /c: for literal?
		;MsgBox(0,"","$s_Command="&$s_Command)
		$i_Pid=RunWait(@ComSpec & " /c " & $s_Command, @ScriptDir, @SW_HIDE)
		ProcessClose($i_Pid)
		$s_AnswerFile = StringReplace($s_AnswerFile, '"', '')
		;MsgBox(0,"after search","$s_AnswerFile="&$s_AnswerFile)
		$s_file = StringReplace($s_file, '"', "")
		If $i_Array Then
			;FileReadToArray($s_AnswerFile, $asList)
			$sList = FileRead($s_AnswerFile, FileGetSize($s_AnswerFile))
			$sList = StringTrimRight(StringReplace($sList, @CRLF, @LF), 1)
			$asList = StringSplit($sList, @LF)
		EndIf
	Else
		SetError(1)
	EndIf
	Return $asList
EndFunc   ;==>_FindLinesDOSsearch2
Func _LockAndWait2()
	Local $Cursor_WAIT
	GUISetState(@SW_LOCK)
	GUISetCursor($Cursor_WAIT, 1)
EndFunc   ;==>_LockAndWait2
Func _ResetLockWait2()
	Local $Cursor_ARROW
	GUISetState(@SW_UNLOCK)
	GUISetCursor($Cursor_ARROW, 1)
EndFunc   ;==>_ResetLockWait2